{
	Code Linguine Source Code Parsing/Query Library
	Copyright (C) 2000-2005 Pavel Simakov
	http://www.softwaresecretweapons.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
}

{     DO NOT EDIT BY HAND! THIS FILE IS AUTO GENERATED!       }


type
  TTemplatedLexer = class(TOYLexer)
  public
    function lex : Integer; override;
  end;

implementation

function TTemplatedLexer.lex : Integer;

  procedure yyaction ( yyruleno : Integer );
    (* local definitions: *)

var
  c : Char;
  e : Array[0..3] of Char;

  procedure OYReturn(const Token : Integer);
  begin
    yyreturn(Token);
  end;

  function OYTokenKind : Integer;
  begin
    Result := TokenKind(yytext);
  end;

  procedure OYParseAsm;
  begin
    repeat
      e[0] := get_char;
      e[1] := get_char;
      e[2] := get_char;
      e[3] := get_char;
      if e[0] = #0 then exit;
      if UpperCase(e) = 'END;' then begin
        unget_char(e[3]);
        yytext := yytext + e[0] + e[1] + e[2];
        break;
      end else begin
        unget_char(e[3]);
        unget_char(e[2]);
        unget_char(e[1]);
        yytext := yytext + e[0]
      end;

      { parse nested comment }
      if e[0] = '{' then begin
        repeat
          c := get_char;
          if c = #0 then break;
          yytext := yytext + c;
          case c of
            '}' : begin
              break;
            end;
          end;
        until false;
      end;


    until false;
    OYReturn(tkAsmBody);
  end;

  procedure OYParseLiteral;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        '''' : begin
          yytext := yytext + c;
          c := get_char;
          case c of
            '''' : begin
              yytext := yytext + c;
            end;
            else begin
              unget_char(c);
              break;
            end;
          end;
        end;
      end;
    until false;
    OYReturn(tkStringLiteral);
  end;


  procedure OYParseSlashesComment;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        #10 : begin
          break;
        end;
      end;
    until false;
    OYReturn(tkSlashesComment);
  end;

  procedure OYParseAnsiComment;
  begin
    repeat
      e[0] := get_char;
      e[1] := get_char;
      e[2] := ' ';
      e[3] := ' ';
      if e[0] = #0 then exit;
      if UpperCase(e) = '*)  ' then begin
        yytext := yytext + e[0] + e[1];
        break;
      end else begin
        yytext := yytext + e[0];
        unget_char(e[1]);
      end;
    until false;
    OYReturn(tkAnsiComment);
  end;

  procedure OYParseBorComment;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        '}' : begin
          break;
        end;
      end;
    until false;
    OYReturn(tkBorComment);
  end;

  procedure OYParseCompilerDirective;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        '{' : begin
          unget_char(c);
          break; 
        end;
        '}' : begin
          break;
        end;
      end;
    until false;
    OYReturn(tkCompiler);
  end;


  begin
    (* actions: *)
    case yyruleno of
  1:
            
        OYParseAsm;
  2:
        OYParseLiteral;
  3:
        OYParseSlashesComment;
  4:
        OYParseAnsiComment;
  5:
        OYParseCompilerDirective;
  6:
        OYParseBorComment;
  7:
                        
        OYReturn(tkInteger);
  8:
                                 
        OYReturn(tkFloat);
  9:
               
        OYReturn(tkFloat);
  10:
               
        OYReturn(tkHex);  
  11:
            
        OYReturn(tkAsciiChar);
  12:
                  
        OYReturn(tkAsciiChar);
  13:
                        
        OYReturn(OYTokenKind);
  14:
         
        OYReturn(tkAsciiChar);
  15:
        OYReturn(tkStringLiteral);
  16:
        OYReturn(tkAssign);
  17:
   			OYReturn(tkColon);
  18:
   			OYReturn(tkComma);
  19:
   			OYReturn(tkPoint);
  20:
    		OYReturn(tkDotDot);
  21:
    		OYReturn(tkLowerEqual);
  22:
    		OYReturn(tkNotEqual);
  23:
    		OYReturn(tkGreaterEqual);
  24:
   			OYReturn(tkGreater);
  25:
   			OYReturn(tkSquareOpen);
  26:
   			OYReturn(tkLower);
  27:
   			OYReturn(tkMinus);
  28:
   			OYReturn(tkPlus);
  29:
   			OYReturn(tkSquareClose);
  30:
   			OYReturn(tkSemiColon);
  31:
   			OYReturn(tkAddressOf);
  32:
   			OYReturn(tkRoundOpen);
  33:
   			OYReturn(tkRoundClose);
  34:
   			OYReturn(tkSlash);
  35:
   			OYReturn(tkStar);
  36:
   			OYReturn(tkDeref);
  37:
   			OYReturn(tkEqual);
  38:
        OYReturn(tkSpace);
  39:
        OYReturn(tkCRLF);
  40:
        OYReturn(tkCRLF);
  41:
        OYReturn(tkCRLF);
  42:
 			  OYReturn(tkUnknown);


    end;
  end(*yyaction*);

(* DFA table: *)

type YYTRec = record
                cc : set of Char;
                s  : Integer;
              end;

const

yynmarks   = 78;
yynmatches = 79;
yyntrans   = 102;
yynstates  = 57;

yyk : array [1..yynmarks] of Integer = (
  { 0: }
  { 1: }
  { 2: }
  13,
  42,
  { 3: }
  2,
  42,
  { 4: }
  34,
  42,
  { 5: }
  32,
  42,
  { 6: }
  6,
  42,
  { 7: }
  7,
  42,
  { 8: }
  42,
  { 9: }
  42,
  { 10: }
  13,
  42,
  { 11: }
  17,
  42,
  { 12: }
  18,
  42,
  { 13: }
  19,
  42,
  { 14: }
  26,
  42,
  { 15: }
  24,
  42,
  { 16: }
  25,
  42,
  { 17: }
  27,
  42,
  { 18: }
  28,
  42,
  { 19: }
  29,
  42,
  { 20: }
  30,
  42,
  { 21: }
  31,
  42,
  { 22: }
  33,
  42,
  { 23: }
  35,
  42,
  { 24: }
  36,
  42,
  { 25: }
  37,
  42,
  { 26: }
  38,
  42,
  { 27: }
  39,
  { 28: }
  40,
  42,
  { 29: }
  41,
  42,
  { 30: }
  42,
  { 31: }
  13,
  { 32: }
  13,
  { 33: }
  15,
  { 34: }
  3,
  { 35: }
  4,
  { 36: }
  5,
  { 37: }
  7,
  { 38: }
  { 39: }
  9,
  { 40: }
  10,
  { 41: }
  { 42: }
  14,
  { 43: }
  16,
  { 44: }
  20,
  { 45: }
  21,
  { 46: }
  22,
  { 47: }
  23,
  { 48: }
  1,
  13,
  { 49: }
  7,
  { 50: }
  8,
  { 51: }
  { 52: }
  11,
  12,
  { 53: }
  12,
  { 54: }
  8,
  { 55: }
  { 56: }
  8
);

yym : array [1..yynmatches] of Integer = (
{ 0: }
{ 1: }
{ 2: }
  13,
  42,
{ 3: }
  2,
  42,
{ 4: }
  34,
  42,
{ 5: }
  32,
  42,
{ 6: }
  6,
  42,
{ 7: }
  7,
  42,
{ 8: }
  42,
{ 9: }
  42,
{ 10: }
  13,
  42,
{ 11: }
  17,
  42,
{ 12: }
  18,
  42,
{ 13: }
  19,
  42,
{ 14: }
  26,
  42,
{ 15: }
  24,
  42,
{ 16: }
  25,
  42,
{ 17: }
  27,
  42,
{ 18: }
  28,
  42,
{ 19: }
  29,
  42,
{ 20: }
  30,
  42,
{ 21: }
  31,
  42,
{ 22: }
  33,
  42,
{ 23: }
  35,
  42,
{ 24: }
  36,
  42,
{ 25: }
  37,
  42,
{ 26: }
  38,
  42,
{ 27: }
  39,
{ 28: }
  40,
  42,
{ 29: }
  41,
  42,
{ 30: }
  42,
{ 31: }
  13,
{ 32: }
  13,
{ 33: }
  15,
{ 34: }
  3,
{ 35: }
  4,
{ 36: }
  5,
{ 37: }
  7,
{ 38: }
{ 39: }
{ 40: }
  10,
{ 41: }
{ 42: }
  14,
{ 43: }
  16,
{ 44: }
  20,
{ 45: }
  21,
{ 46: }
  22,
{ 47: }
  23,
{ 48: }
  1,
  13,
{ 49: }
  7,
{ 50: }
  8,
  9,
{ 51: }
  9,
{ 52: }
  11,
  12,
{ 53: }
  12,
{ 54: }
  8,
{ 55: }
{ 56: }
  8
);

yyt : array [1..yyntrans] of YYTrec = (
{ 0: }
  ( cc: [ #1..#9,#11,#14..#31,'!','"','%','&','?','\',
            '`','|'..#255 ]; s: 30),
  ( cc: [ #10 ]; s: 27),
  ( cc: [ #12 ]; s: 28),
  ( cc: [ #13 ]; s: 29),
  ( cc: [ ' ' ]; s: 26),
  ( cc: [ '#' ]; s: 9),
  ( cc: [ '$' ]; s: 8),
  ( cc: [ '''' ]; s: 3),
  ( cc: [ '(' ]; s: 5),
  ( cc: [ ')' ]; s: 22),
  ( cc: [ '*' ]; s: 23),
  ( cc: [ '+' ]; s: 18),
  ( cc: [ ',' ]; s: 12),
  ( cc: [ '-' ]; s: 17),
  ( cc: [ '.' ]; s: 13),
  ( cc: [ '/' ]; s: 4),
  ( cc: [ '0'..'9' ]; s: 7),
  ( cc: [ ':' ]; s: 11),
  ( cc: [ ';' ]; s: 20),
  ( cc: [ '<' ]; s: 14),
  ( cc: [ '=' ]; s: 25),
  ( cc: [ '>' ]; s: 15),
  ( cc: [ '@' ]; s: 21),
  ( cc: [ 'A','a' ]; s: 2),
  ( cc: [ 'B'..'Z','_','b'..'z' ]; s: 10),
  ( cc: [ '[' ]; s: 16),
  ( cc: [ ']' ]; s: 19),
  ( cc: [ '^' ]; s: 24),
  ( cc: [ '{' ]; s: 6),
{ 1: }
  ( cc: [ #1..#9,#11,#14..#31,'!','"','%','&','?','\',
            '`','|'..#255 ]; s: 30),
  ( cc: [ #10 ]; s: 27),
  ( cc: [ #12 ]; s: 28),
  ( cc: [ #13 ]; s: 29),
  ( cc: [ ' ' ]; s: 26),
  ( cc: [ '#' ]; s: 9),
  ( cc: [ '$' ]; s: 8),
  ( cc: [ '''' ]; s: 3),
  ( cc: [ '(' ]; s: 5),
  ( cc: [ ')' ]; s: 22),
  ( cc: [ '*' ]; s: 23),
  ( cc: [ '+' ]; s: 18),
  ( cc: [ ',' ]; s: 12),
  ( cc: [ '-' ]; s: 17),
  ( cc: [ '.' ]; s: 13),
  ( cc: [ '/' ]; s: 4),
  ( cc: [ '0'..'9' ]; s: 7),
  ( cc: [ ':' ]; s: 11),
  ( cc: [ ';' ]; s: 20),
  ( cc: [ '<' ]; s: 14),
  ( cc: [ '=' ]; s: 25),
  ( cc: [ '>' ]; s: 15),
  ( cc: [ '@' ]; s: 21),
  ( cc: [ 'A','a' ]; s: 2),
  ( cc: [ 'B'..'Z','_','b'..'z' ]; s: 10),
  ( cc: [ '[' ]; s: 16),
  ( cc: [ ']' ]; s: 19),
  ( cc: [ '^' ]; s: 24),
  ( cc: [ '{' ]; s: 6),
{ 2: }
  ( cc: [ '0'..'9','A'..'R','T'..'Z','_','a'..'r','t'..'z' ]; s: 32),
  ( cc: [ 'S','s' ]; s: 31),
{ 3: }
  ( cc: [ '''' ]; s: 33),
{ 4: }
  ( cc: [ '/' ]; s: 34),
{ 5: }
  ( cc: [ '*' ]; s: 35),
{ 6: }
  ( cc: [ '$' ]; s: 36),
{ 7: }
  ( cc: [ '.' ]; s: 39),
  ( cc: [ '0'..'9' ]; s: 37),
  ( cc: [ 'E','e' ]; s: 38),
{ 8: }
  ( cc: [ '0'..'9','A'..'F','a'..'f' ]; s: 40),
{ 9: }
  ( cc: [ '$' ]; s: 41),
  ( cc: [ '0'..'9' ]; s: 42),
{ 10: }
  ( cc: [ '0'..'9','A'..'Z','_','a'..'z' ]; s: 32),
{ 11: }
  ( cc: [ '=' ]; s: 43),
{ 12: }
{ 13: }
  ( cc: [ '.' ]; s: 44),
{ 14: }
  ( cc: [ '=' ]; s: 45),
  ( cc: [ '>' ]; s: 46),
{ 15: }
  ( cc: [ '=' ]; s: 47),
{ 16: }
{ 17: }
{ 18: }
{ 19: }
{ 20: }
{ 21: }
{ 22: }
{ 23: }
{ 24: }
{ 25: }
{ 26: }
{ 27: }
{ 28: }
{ 29: }
{ 30: }
{ 31: }
  ( cc: [ '0'..'9','A'..'L','N'..'Z','_','a'..'l','n'..'z' ]; s: 32),
  ( cc: [ 'M','m' ]; s: 48),
{ 32: }
  ( cc: [ '0'..'9','A'..'Z','_','a'..'z' ]; s: 32),
{ 33: }
{ 34: }
{ 35: }
{ 36: }
{ 37: }
  ( cc: [ '.' ]; s: 39),
  ( cc: [ '0'..'9' ]; s: 37),
  ( cc: [ 'E','e' ]; s: 38),
{ 38: }
  ( cc: [ '+','-' ]; s: 38),
  ( cc: [ '0'..'9' ]; s: 49),
{ 39: }
  ( cc: [ #1..'-','/',':'..#255 ]; s: 51),
  ( cc: [ '0'..'9' ]; s: 50),
{ 40: }
  ( cc: [ '0'..'9','A'..'F','a'..'f' ]; s: 40),
{ 41: }
  ( cc: [ '0'..'9' ]; s: 52),
  ( cc: [ 'A'..'E','a'..'e' ]; s: 53),
{ 42: }
  ( cc: [ '0'..'9' ]; s: 42),
{ 43: }
{ 44: }
{ 45: }
{ 46: }
{ 47: }
{ 48: }
  ( cc: [ '0'..'9','A'..'Z','_','a'..'z' ]; s: 32),
{ 49: }
  ( cc: [ '0'..'9' ]; s: 49),
{ 50: }
  ( cc: [ '0'..'9' ]; s: 54),
  ( cc: [ 'E','e' ]; s: 55),
{ 51: }
{ 52: }
  ( cc: [ '0'..'9' ]; s: 52),
  ( cc: [ 'A'..'E','a'..'e' ]; s: 53),
{ 53: }
  ( cc: [ '0'..'9','A'..'E','a'..'e' ]; s: 53),
{ 54: }
  ( cc: [ '0'..'9' ]; s: 54),
  ( cc: [ 'E','e' ]; s: 55),
{ 55: }
  ( cc: [ '+','-' ]; s: 55),
  ( cc: [ '0'..'9' ]; s: 56),
{ 56: }
  ( cc: [ '0'..'9' ]; s: 56)
);

yykl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 1,
{ 3: } 3,
{ 4: } 5,
{ 5: } 7,
{ 6: } 9,
{ 7: } 11,
{ 8: } 13,
{ 9: } 14,
{ 10: } 15,
{ 11: } 17,
{ 12: } 19,
{ 13: } 21,
{ 14: } 23,
{ 15: } 25,
{ 16: } 27,
{ 17: } 29,
{ 18: } 31,
{ 19: } 33,
{ 20: } 35,
{ 21: } 37,
{ 22: } 39,
{ 23: } 41,
{ 24: } 43,
{ 25: } 45,
{ 26: } 47,
{ 27: } 49,
{ 28: } 50,
{ 29: } 52,
{ 30: } 54,
{ 31: } 55,
{ 32: } 56,
{ 33: } 57,
{ 34: } 58,
{ 35: } 59,
{ 36: } 60,
{ 37: } 61,
{ 38: } 62,
{ 39: } 62,
{ 40: } 63,
{ 41: } 64,
{ 42: } 64,
{ 43: } 65,
{ 44: } 66,
{ 45: } 67,
{ 46: } 68,
{ 47: } 69,
{ 48: } 70,
{ 49: } 72,
{ 50: } 73,
{ 51: } 74,
{ 52: } 74,
{ 53: } 76,
{ 54: } 77,
{ 55: } 78,
{ 56: } 78
);

yykh : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 2,
{ 3: } 4,
{ 4: } 6,
{ 5: } 8,
{ 6: } 10,
{ 7: } 12,
{ 8: } 13,
{ 9: } 14,
{ 10: } 16,
{ 11: } 18,
{ 12: } 20,
{ 13: } 22,
{ 14: } 24,
{ 15: } 26,
{ 16: } 28,
{ 17: } 30,
{ 18: } 32,
{ 19: } 34,
{ 20: } 36,
{ 21: } 38,
{ 22: } 40,
{ 23: } 42,
{ 24: } 44,
{ 25: } 46,
{ 26: } 48,
{ 27: } 49,
{ 28: } 51,
{ 29: } 53,
{ 30: } 54,
{ 31: } 55,
{ 32: } 56,
{ 33: } 57,
{ 34: } 58,
{ 35: } 59,
{ 36: } 60,
{ 37: } 61,
{ 38: } 61,
{ 39: } 62,
{ 40: } 63,
{ 41: } 63,
{ 42: } 64,
{ 43: } 65,
{ 44: } 66,
{ 45: } 67,
{ 46: } 68,
{ 47: } 69,
{ 48: } 71,
{ 49: } 72,
{ 50: } 73,
{ 51: } 73,
{ 52: } 75,
{ 53: } 76,
{ 54: } 77,
{ 55: } 77,
{ 56: } 78
);

yyml : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 1,
{ 2: } 1,
{ 3: } 3,
{ 4: } 5,
{ 5: } 7,
{ 6: } 9,
{ 7: } 11,
{ 8: } 13,
{ 9: } 14,
{ 10: } 15,
{ 11: } 17,
{ 12: } 19,
{ 13: } 21,
{ 14: } 23,
{ 15: } 25,
{ 16: } 27,
{ 17: } 29,
{ 18: } 31,
{ 19: } 33,
{ 20: } 35,
{ 21: } 37,
{ 22: } 39,
{ 23: } 41,
{ 24: } 43,
{ 25: } 45,
{ 26: } 47,
{ 27: } 49,
{ 28: } 50,
{ 29: } 52,
{ 30: } 54,
{ 31: } 55,
{ 32: } 56,
{ 33: } 57,
{ 34: } 58,
{ 35: } 59,
{ 36: } 60,
{ 37: } 61,
{ 38: } 62,
{ 39: } 62,
{ 40: } 62,
{ 41: } 63,
{ 42: } 63,
{ 43: } 64,
{ 44: } 65,
{ 45: } 66,
{ 46: } 67,
{ 47: } 68,
{ 48: } 69,
{ 49: } 71,
{ 50: } 72,
{ 51: } 74,
{ 52: } 75,
{ 53: } 77,
{ 54: } 78,
{ 55: } 79,
{ 56: } 79
);

yymh : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 2,
{ 3: } 4,
{ 4: } 6,
{ 5: } 8,
{ 6: } 10,
{ 7: } 12,
{ 8: } 13,
{ 9: } 14,
{ 10: } 16,
{ 11: } 18,
{ 12: } 20,
{ 13: } 22,
{ 14: } 24,
{ 15: } 26,
{ 16: } 28,
{ 17: } 30,
{ 18: } 32,
{ 19: } 34,
{ 20: } 36,
{ 21: } 38,
{ 22: } 40,
{ 23: } 42,
{ 24: } 44,
{ 25: } 46,
{ 26: } 48,
{ 27: } 49,
{ 28: } 51,
{ 29: } 53,
{ 30: } 54,
{ 31: } 55,
{ 32: } 56,
{ 33: } 57,
{ 34: } 58,
{ 35: } 59,
{ 36: } 60,
{ 37: } 61,
{ 38: } 61,
{ 39: } 61,
{ 40: } 62,
{ 41: } 62,
{ 42: } 63,
{ 43: } 64,
{ 44: } 65,
{ 45: } 66,
{ 46: } 67,
{ 47: } 68,
{ 48: } 70,
{ 49: } 71,
{ 50: } 73,
{ 51: } 74,
{ 52: } 76,
{ 53: } 77,
{ 54: } 78,
{ 55: } 78,
{ 56: } 79
);

yytl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 30,
{ 2: } 59,
{ 3: } 61,
{ 4: } 62,
{ 5: } 63,
{ 6: } 64,
{ 7: } 65,
{ 8: } 68,
{ 9: } 69,
{ 10: } 71,
{ 11: } 72,
{ 12: } 73,
{ 13: } 73,
{ 14: } 74,
{ 15: } 76,
{ 16: } 77,
{ 17: } 77,
{ 18: } 77,
{ 19: } 77,
{ 20: } 77,
{ 21: } 77,
{ 22: } 77,
{ 23: } 77,
{ 24: } 77,
{ 25: } 77,
{ 26: } 77,
{ 27: } 77,
{ 28: } 77,
{ 29: } 77,
{ 30: } 77,
{ 31: } 77,
{ 32: } 79,
{ 33: } 80,
{ 34: } 80,
{ 35: } 80,
{ 36: } 80,
{ 37: } 80,
{ 38: } 83,
{ 39: } 85,
{ 40: } 87,
{ 41: } 88,
{ 42: } 90,
{ 43: } 91,
{ 44: } 91,
{ 45: } 91,
{ 46: } 91,
{ 47: } 91,
{ 48: } 91,
{ 49: } 92,
{ 50: } 93,
{ 51: } 95,
{ 52: } 95,
{ 53: } 97,
{ 54: } 98,
{ 55: } 100,
{ 56: } 102
);

yyth : array [0..yynstates-1] of Integer = (
{ 0: } 29,
{ 1: } 58,
{ 2: } 60,
{ 3: } 61,
{ 4: } 62,
{ 5: } 63,
{ 6: } 64,
{ 7: } 67,
{ 8: } 68,
{ 9: } 70,
{ 10: } 71,
{ 11: } 72,
{ 12: } 72,
{ 13: } 73,
{ 14: } 75,
{ 15: } 76,
{ 16: } 76,
{ 17: } 76,
{ 18: } 76,
{ 19: } 76,
{ 20: } 76,
{ 21: } 76,
{ 22: } 76,
{ 23: } 76,
{ 24: } 76,
{ 25: } 76,
{ 26: } 76,
{ 27: } 76,
{ 28: } 76,
{ 29: } 76,
{ 30: } 76,
{ 31: } 78,
{ 32: } 79,
{ 33: } 79,
{ 34: } 79,
{ 35: } 79,
{ 36: } 79,
{ 37: } 82,
{ 38: } 84,
{ 39: } 86,
{ 40: } 87,
{ 41: } 89,
{ 42: } 90,
{ 43: } 90,
{ 44: } 90,
{ 45: } 90,
{ 46: } 90,
{ 47: } 90,
{ 48: } 91,
{ 49: } 92,
{ 50: } 94,
{ 51: } 94,
{ 52: } 96,
{ 53: } 97,
{ 54: } 99,
{ 55: } 101,
{ 56: } 102
);


var yyn : Integer;

label start, scan, action;

begin

  (*update current frame information*)
  yyshiftFrame;

start:

  (* initialize: *)

  yynew;

scan:

  (* mark positions and matches: *)

  for yyn := yykl[yystate] to     yykh[yystate] do yymark(yyk[yyn]);
  for yyn := yymh[yystate] downto yyml[yystate] do yymatch(yym[yyn]);

  if yytl[yystate]>yyth[yystate] then goto action; (* dead state *)

  (* get next character: *)

  yyscan;

  (* determine action: *)

  yyn := yytl[yystate];
  while (yyn<=yyth[yystate]) and not (yyactchar in yyt[yyn].cc) do inc(yyn);
  if yyn>yyth[yystate] then goto action;
    (* no transition on yyactchar in this state *)

  (* switch to new state: *)

  yystate := yyt[yyn].s;

  goto scan;

action:

  (* execute action: *)

  if yyfind(yyrule) then
    begin
      yyaction(yyrule);
      if yyrejected then goto action;
    end
  else if not yydefault and yywrap then
    begin
      yyclear;
      yyreturn(0);
    end;

  if not yydone then goto start;

  fFrame.id := yyretval;
  Result := fFrame.id;
                                   
end(*lex*);

