%
{
	Code Linguine Source Code Parsing/Query Library
	Copyright (C) 2000-2005 Pavel Simakov
	http://www.softwaresecretweapons.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
}

{     DO NOT EDIT BY HAND! THIS FILE IS AUTO GENERATED!       }
%}

%%

%{
var
  c : Char;
  e : Array[0..3] of Char;

  procedure OYReturn(const Token : Integer);
  begin
    yyreturn(Token);
  end;

  function OYTokenKind : Integer;
  begin
    Result := TokenKind(yytext);
  end;

  procedure OYParseAsm;
  begin
    repeat
      e[0] := get_char;
      e[1] := get_char;
      e[2] := get_char;
      e[3] := get_char;
      if e[0] = #0 then exit;
      if UpperCase(e) = 'END;' then begin
        unget_char(e[3]);
        yytext := yytext + e[0] + e[1] + e[2];
        break;
      end else begin
        unget_char(e[3]);
        unget_char(e[2]);
        unget_char(e[1]);
        yytext := yytext + e[0]
      end;

      { parse nested comment }
      if e[0] = '{' then begin
        repeat
          c := get_char;
          if c = #0 then break;
          yytext := yytext + c;
          case c of
            '}' : begin
              break;
            end;
          end;
        until false;
      end;


    until false;
    OYReturn(tkAsmBody);
  end;

  procedure OYParseLiteral;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        '''' : begin
          yytext := yytext + c;
          c := get_char;
          case c of
            '''' : begin
              yytext := yytext + c;
            end;
            else begin
              unget_char(c);
              break;
            end;
          end;
        end;
      end;
    until false;
    OYReturn(tkStringLiteral);
  end;


  procedure OYParseSlashesComment;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        #10 : begin
          break;
        end;
      end;
    until false;
    OYReturn(tkSlashesComment);
  end;

  procedure OYParseAnsiComment;
  begin
    repeat
      e[0] := get_char;
      e[1] := get_char;
      e[2] := ' ';
      e[3] := ' ';
      if e[0] = #0 then exit;
      if UpperCase(e) = '*)  ' then begin
        yytext := yytext + e[0] + e[1];
        break;
      end else begin
        yytext := yytext + e[0];
        unget_char(e[1]);
      end;
    until false;
    OYReturn(tkAnsiComment);
  end;

  procedure OYParseBorComment;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        '}' : begin
          break;
        end;
      end;
    until false;
    OYReturn(tkBorComment);
  end;

  procedure OYParseCompilerDirective;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        '{' : begin
          unget_char(c);
          break; 
        end;
        '}' : begin
          break;
        end;
      end;
    until false;
    OYReturn(tkCompiler);
  end;

%}

[aA][sS][mM]
        OYParseAsm;
"'"     OYParseLiteral;
"//"    OYParseSlashesComment;
"(*"    OYParseAnsiComment;
"{$"    OYParseCompilerDirective;
"{"     OYParseBorComment;
[0-9]+([eE][+-]*[0-9]+)?
        OYReturn(tkInteger);
[0-9]+"."[0-9]+([eE][+-]*[0-9]+)?
        OYReturn(tkFloat);
[0-9]+"."/[^\.]
        OYReturn(tkFloat);
[$][0-9a-fA-F]+
        OYReturn(tkHex);  
[#][$][0-9]+
        OYReturn(tkAsciiChar);
[#][$][0-9a-eA-E]+
        OYReturn(tkAsciiChar);
[_a-zA-Z]([_a-zA-Z0-9])*
        OYReturn(OYTokenKind);
[#][0-9]+
        OYReturn(tkAsciiChar);
"''"    OYReturn(tkStringLiteral);
":="    OYReturn(tkAssign);
":"			OYReturn(tkColon);
","			OYReturn(tkComma);
"."			OYReturn(tkPoint);
".."		OYReturn(tkDotDot);
"<="		OYReturn(tkLowerEqual);
"<>"		OYReturn(tkNotEqual);
">="		OYReturn(tkGreaterEqual);
">"			OYReturn(tkGreater);
"["			OYReturn(tkSquareOpen);
"<"			OYReturn(tkLower);
"-"			OYReturn(tkMinus);
"+"			OYReturn(tkPlus);
"]"			OYReturn(tkSquareClose);
";"			OYReturn(tkSemiColon);
"@"			OYReturn(tkAddressOf);
"("			OYReturn(tkRoundOpen);
")"			OYReturn(tkRoundClose);
"/"			OYReturn(tkSlash);
"*"			OYReturn(tkStar);
"^"			OYReturn(tkDeref);
"="			OYReturn(tkEqual);
[ ]     OYReturn(tkSpace);
[\n]    OYReturn(tkCRLF);
[\f]    OYReturn(tkCRLF);
[\r]    OYReturn(tkCRLF);
.			  OYReturn(tkUnknown);


