/*
{
	Code Linguine Source Code Parsing/Query Library
	Copyright (C) 2000-2005 Pavel Simakov
	http://www.softwaresecretweapons.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
}

{     DO NOT EDIT BY HAND! THIS FILE IS AUTO GENERATED!       }
*/


/*

  Parsing of all *.pas files in Delphi 5 Enterprise results in 736/738 = 99.7% accuracy. 

  General issues however exist:
                                    
  - optional ';' are not recognized before STDCALL, CDELC, etc.
  - missing semicolons { if Beep then beep else anotherbeep } are not supported                
  - only $I, $INCLUDE, $IFDEF, $IFNDEF, $ELSE, $ENDIF, $DEFINE, $UNDEF are supported
  - function with no result type declared have problems
  - parenthesis in type redifiniton are not recognized => TMyType = (TOldType);  
  - error with multilevel $IFDEF in ..\Raize\RzSplit.pas

*/

%start parse_goal                                                                         

%token
/* tokens that are not part of Pascal or are not classified */
  tkAsciiChar
  tkAsmBody
  tkCompiler             /* compiler directives */
  tkCRLF
  tkFloat
  tkIdentifier
  tkInline
  tkInteger
  tkJunk                 /* white space */
  tkHex
  tkNumber
  tkSpace
  tkStringLiteral
  tkIgnore               /* tokens marked "ignore" by preprocessor */
  tkUnknown

/* comments  */
  tkAnsiComment
  tkBorComment
  tkSlashesComment

/* punctuation characters */
  tkAddressOf
  tkAssign
  tkComma
  tkColon
  tkDeref
  tkDotDot
  tkPoint
  tkRoundOpen
  tkRoundClose
  tkSemiColon
  tkSlashes
  tkSquareOpen
  tkSquareClose
  tkSymbol

/* non reserved word (can server as identifier names) */
  tkAt
  tkOn

/* reserved words (can NOT serve as identifier names) */
  tkArray
  tkBegin
  tkCase
  tkClass
  tkConst
  tkConstructor
  tkContains 
  tkDestructor
  tkDispinterface
  tkDo
  tkDownto
  tkElse
  tkEnd
  tkExcept
  tkExports
  tkFile
  tkFinalization
  tkFinally
  tkFor
  tkFunction
  tkGoto
  tkIf
  tkImplementation
  tkInherited
  tkInitialization
  tkInterface
  tkLabel
  tkLibrary
  tkNil
  tkNot
  tkObject
  tkOf
  tkOut
  tkPackage 
  tkPacked
  tkProcedure
  tkProgram
  tkProperty
  tkRaise
  tkRecord
  tkRepeat
  tkRequires
  tkResourcestring
  tkSet
  tkString
  tkStringResource
  tkThen
  tkThreadvar
  tkTo
  tkTry
  tkType
  tkUnit
  tkUntil
  tkUses
  tkVar
  tkWhile
  tkWith

/* addition operators */
  tkMinus
  tkPlus
  tkOr
  tkXor

/* multiplication operators */
  tkAnd
  tkDiv
  tkMod
  tkShl
  tkShr
  tkSlash
  tkStar

/* relative operators */
  tkAs
  tkEqual
  tkGreater
  tkGreaterEqual
  tkIn
  tkIs
  tkLower
  tkLowerEqual
  tkNotEqual

/* ordinary type identifiers  */
  tkShortInt
  tkSmallInt
  tkOrdInteger
  tkByte
  tkLongInt
  tkInt64
  tkWord
  tkBoolean
  tkChar
  tkWideChar
  tkLongWord
  tkPChar
  tkCardinal

/* real type identifier */
  tkReal48
  tkReal
  tkSingle
  tkDouble
  tkExtended
  tkCurrency
  tkComp

/* string types */
  tkAnsiString
  tkString
  tkWideString

/* variant types */
  tkVariant
  tkOleVariant

/* calling conventions */
  tkRegister
  tkPascal
  tkNear
  tkFar
  tkCdecl
  tkSafecall
  tkStdcall

/* directives */
  tkAbsolute
  tkAbstract
  tkAssembler
  tkAutomated
  tkContains
  tkDefault
  tkDispid
  tkDynamic
  tkExport
  tkExternal
  tkForward
  tkImplements
  tkIndex
  tkMessage
  tkName
  tkNodefault
  tkOverload
  tkOverride
  tkPackage
  tkPascal
  tkPrivate
  tkProtected
  tkPublic
  tkPublished
  tkRead
  tkReadOnly
  tkRegister
  tkReintroduce
  tkRequires
  tkResident
  tkStored
  tkVirtual
  tkWrite
  tkWriteOnly

%right tkThen tkElse

%%

parse_goal
  : program_file
  | unit_file
  | library_file
  | package_file
  ;


/*  error recovery is possible by skipping input util these "stable" tokens */
error_recovery
        : tkInterface
        | tkimplementation
        | tkVar  
        | tkConst
        | tkType            
        | tkResourceString
        | tkObject
        | tkFunction
        | tkProcedure
        | tkBegin
        | tkEnd
        | tkSemiColon
        ;

/* Structure of program */
program_file
        : program_heading main_uses_clause program_block tkPoint
        ;

program_heading
        : /* empty */ {}
        | tkProgram program_name program_heading_2
        ;

program_heading_2
        : tkSemiColon
        | tkRoundOpen program_param_list tkRoundClose tkSemiColon
        ;

program_name
        : tkIdentifier
        ;

program_param_list
        : program_param
        | program_param_list tkComma program_param
        ;

program_param
        : tkIdentifier
        ;

program_block
        : program_decl_sect_list compound_stmt
        ;

program_decl_sect_list
        : impl_decl_sect_list
        ;

uses_clause
        : /* empty */ {}
        | tkUses used_units_list tkSemiColon
        ;

used_units_list
        : used_units_list tkComma used_unit_name
        | used_unit_name
        ;

used_unit_name
        : tkIdentifier
        ;

main_uses_clause
        : /* empty */ {}
        | tkUses main_used_units_list tkSemiColon
        ;

main_used_units_list
        : main_used_units_list tkComma main_used_unit_name
        | main_used_unit_name
        ;

main_used_unit_name
        : tkIdentifier
        | tkIdentifier tkIn tkStringLiteral
        ;


/* Structure of library */
library_file
        : library_heading main_uses_clause library_block tkPoint
        ;

library_heading
        : tkLibrary tkIdentifier tkSemiColon
        ;

library_block
        : library_impl_decl_sect_list compound_stmt
        ;

library_impl_decl_sect_list
        : /* empty */ {}
        | library_impl_decl_sect_list library_impl_decl_sect
        ;

library_impl_decl_sect
        : label_decl_sect
        | const_decl_sect
        | res_str_decl_sect
        | type_decl_sect
        | var_decl_sect
        | proc_decl
        | func_decl
        | constructor_decl
        | destructor_decl
        | export_clause
        ;

export_clause
        : tkExports exports_list tkSemiColon
        ;

exports_list
        : exports_entry
        | exports_list tkComma exports_entry
        ;

exports_entry
        : identifier exports_index exports_name exports_resident
        ;

exports_index
        : /* empty */ {}
        | tkIndex integer_const
        ;

exports_name
        : /* empty */ {}
        | tkName identifier
        | tkName literal  
        ;          

exports_resident
        : /* empty */ {}
        | tkResident
        ;


/* Structure of unit */
unit_file
        : unit_heading interface_part implementation_part initialization_part tkPoint
        ;

unit_heading
        : tkUnit unit_name tkSemiColon
        ;

unit_name
        : tkIdentifier
        ;

interface_part
        : tkInterface uses_clause int_decl_sect_list
        ;

implementation_part
        : tkImplementation uses_clause impl_decl_sect_list
        ;

initialization_part       
        : tkEnd
        | tkInitialization stmt_list tkEnd
        | tkInitialization stmt_list tkFinalization stmt_list tkEnd
        | tkBegin stmt_list tkEnd
        ;                                    

        
/* Structure of package */
package_file
        : tkPackage package_name tkSemiColon requires_clause contains_clause tkEnd tkPoint
        ;                                                                            
                                                              
package_name
        : identifier
        ;

requires_clause
        : /* empty */ {}
        | tkRequires
        | tkRequires main_used_units_list tkSemiColon
        ;

contains_clause
        : /* empty */ {}
        | tkContains
        | tkContains main_used_units_list tkSemiColon
        ;                   


/* Declaration sections: */

int_decl_sect_list
        : /* empty */ {}
        | int_decl_sect_list int_decl_sect
        ;

impl_decl_sect_list
        : /* empty */ {}
        | impl_decl_sect_list impl_decl_sect
        ;

int_decl_sect
        : const_decl_sect
        | res_str_decl_sect
        | type_decl_sect
        | var_decl_sect
        | int_proc_heading
        | int_func_heading  
        ;

impl_decl_sect
        : label_decl_sect
        | const_decl_sect
        | res_str_decl_sect
        | type_decl_sect
        | var_decl_sect
        | proc_decl
        | func_decl
        | constructor_decl
        | destructor_decl                                                               
        ;

int_proc_heading
        : proc_heading
        | proc_heading inline_directr tkSemiColon
        | proc_heading tkForward tkSemiColon
        | proc_heading fp_directives
        ;               

int_func_heading
        : func_heading
        | func_heading inline_directr tkSemiColon
        | func_heading tkForward tkSemiColon
        | func_heading fp_directives
        ;                                                                                 

label_decl_sect
        : tkLabel label_list tkSemiColon
        ;

label_list
        : label_name
        | label_list tkComma label_name
        ;

label_name
        : tkInteger
        | identifier
        ;

const_decl_sect
        : tkConst const_decl
        | const_decl_sect const_decl
        ;

res_str_decl_sect
        : tkResourcestring const_decl
        | res_str_decl_sect const_decl
        ;

type_decl_sect
        : tkType type_decl
        | type_decl_sect type_decl
        ;

var_decl_sect
        : tkVar var_decl
        | tkThreadvar var_decl
        | var_decl_sect var_decl
        ;

const_decl
        : const_name tkEqual const_expr tkSemiColon
        | const_name tkColon type_ref tkEqual typed_const tkSemiColon
        ;

const_name
        : identifier
        ;


/* Constant Expressions and calculated constants */
const_expr
        : const_simple_expr
        | const_simple_expr const_relop const_simple_expr
        ;

const_relop
        : tkEqual | tkNotEqual | tkLower | tkGreater
        | tkLowerEqual | tkGreaterEqual | tkIn
        ;

const_simple_expr
        : const_term
        | const_simple_expr const_addop const_term
        ;

const_addop
        : tkPlus
        | tkMinus
        | tkOr
        | tkXor
        ;

const_term
        : const_factor
        | const_term const_mulop const_factor
        ;

const_mulop
        : tkStar | tkSlash | tkDiv | tkMod | tkShl | tkShr | tkAnd ;

const_factor
        : const_variable
        | const_set
        | unsigned_number
        | literal
        | tkNil
        | tkAddressOf const_factor
        | tkRoundOpen const_expr tkRoundClose
        | tkNot const_factor
        | sign const_factor
        | tkDeref const_factor
        ;

const_set
        : tkSquareOpen const_elem_list tkSquareClose
        ;

sign    : tkPlus
        | tkMinus
        ;

const_variable
        : identifier
        | const_variable const_variable_2
        ;

const_variable_2
        : tkPoint identifier
        | tkDeref
        | tkRoundOpen const_func_expr_list tkRoundClose
        ;

const_func_expr_list
        : const_expr
        | const_expr tkComma const_expr
        ;

const_elem_list
        : /* empty */ {}
        | const_elem_list1
        ;

const_elem_list1
        : const_elem
        | const_elem_list1 tkComma const_elem
        ;

const_elem
        : const_expr
        | const_expr tkDotDot const_expr
        ;

unsigned_number
        : tkInteger
        | tkHex
        | tkFloat
        ;

typed_const
        : const_expr
        | array_const
        | record_const
        ;                       

array_const
        : tkRoundOpen typed_const_list tkRoundClose
        | tkRoundOpen record_const tkRoundClose
        | tkRoundOpen array_const tkRoundClose
        ;

typed_const_list
        : /* empty */ {}
        | typed_const tkComma typed_const
        | typed_const_list tkComma typed_const
        ;

record_const
        : tkRoundOpen const_field_list tkRoundClose          
        ;

const_field_list
        : const_field tkSemiColon const_field_list
        | const_field tkSemiColon
        | const_field
        ;

const_field
        : const_field_name tkColon typed_const
        ;

const_field_name
        : identifier
        ;

                                      
/* Types declarations */              
type_decl
        : identifier tkEqual type_decl_type tkSemiColon
        | error error_recovery { yywarning('Ambigious syntax in type declaration.'); yyerrok; }
        ;

type_decl_type
        : type_ref
        | tkType type_ref
        | object_type
        ;

type_ref
        : simple_type
        | string_type
        | pointer_type
        | structured_type
        | procedural_type
        ;

simple_type
        : ord_type_name
        | real_type_name
        | variant_type_name
        | simple_type_identifier
        | range_expr tkDotDot range_expr
        | tkRoundOpen enumeration_id_list tkRoundClose
        ;

range_expr
        : range_term
        | range_expr const_addop range_term
        ;

range_term
        : range_factor
        | range_term const_mulop range_factor
        ;

range_factor
        : identifier
        | unsigned_number
        | sign range_factor
        | literal
        | identifier tkRoundOpen const_expr tkRoundClose
        | tkRoundOpen const_expr tkRoundClose
        ;

simple_type_identifier
        : tkIdentifier
        | unit_name tkPoint identifier
        ;

enumeration_id_list
        : enumeration_id tkComma enumeration_id
        | enumeration_id_list tkComma enumeration_id
        ;

enumeration_id
        : identifier
        ;

pointer_type
        : tkDeref identifier
        ;

structured_type
        : unpacked_structured_type
        | tkPacked unpacked_structured_type
        ;

unpacked_structured_type
        : array_type
        | record_type
        | set_type
        | file_type
        ;

array_type
        : tkArray tkSquareOpen simple_type_list tkSquareClose tkOf type_ref
        | tkArray tkOf type_ref
        ;

simple_type_list
        : simple_type
        | simple_type_list tkComma simple_type
        ;

record_type
        : tkRecord field_list tkEnd
        | tkRecord tkEnd
        ;

field_list
        : fixed_part
        | variant_part
        | fixed_part_2 tkSemiColon variant_part
        ;

fixed_part
        : fixed_part_2
        | fixed_part_2 tkSemiColon
        ;

fixed_part_2
        : record_section
        | fixed_part_2 tkSemiColon record_section
        ;

record_section
        : record_section_id_list tkColon type_ref
        ;

record_section_id_list
        : record_section_id
        | record_section_id_list tkComma record_section_id
        ;

record_section_id
        : identifier
        ;

variant_part
        : tkCase tag_field tkOf variant_list
        ;

tag_field
        : tag_field_name
        | tag_field_name tkColon tag_field_typename
        ;

tag_field_name
        : identifier
        ;

tag_field_typename
        : identifier
        ;

variant_list
        : variant_list_2
        | variant_list_2 tkSemiColon
        ;

variant_list_2
        : variant
        | variant_list_2 tkSemiColon variant
        ;

variant : case_tag_list tkColon tkRoundOpen variant_field_list tkRoundClose
        ;

variant_field_list
        : /* empty */ {}
        | field_list
        ;

case_tag_list
        : const_expr
        | case_tag_list tkComma const_expr
        ;

set_type
        : tkSet tkOf simple_type
        ;

file_type
        : tkFile tkOf type_ref
        | tkFile
        ;

string_type
        : string_type_name
        | tkString tkSquareOpen const_expr tkSquareClose
        ;

procedural_type
        : procedural_type_kind
        | procedural_type_kind calling_conventions
        ;                                  

procedural_type_kind
        : procedural_type_decl
        | procedural_type_decl tkOf tkObject
        ;                                    

procedural_type_decl
        : tkProcedure fp_list
        | tkFunction fp_list tkColon fptype
        ;

object_type
        : new_object_type
        | old_object_type
        ;

old_object_type
        : tkObject oot_successor oot_component_list oot_privat_list tkEnd
        ;

oot_privat_list
        :  /* empty */ {}
        | tkPrivate oot_component_list
        ;

oot_component_list
        : /* empty */ {}
        | oot_field_list
        | oot_field_list oot_method_list
        | oot_method_list
        ;

oot_successor
        : tkRoundOpen oot_typeidentifier tkRoundClose
        ;

oot_typeidentifier
        : identifier
        ;

oot_field_list
        : oot_field
        | oot_field_list oot_field
        ;

oot_field
        : oot_id_list tkColon type_ref tkSemiColon
        ;

oot_id_list
        : oot_field_identifier
        | oot_id_list tkComma oot_field_identifier
        ;

oot_field_identifier
        : identifier
        ;

oot_method_list
        : oot_method
        | oot_method_list oot_method
        ;

oot_method 
        : oot_method_head
        ;

oot_method_head
        : proc_heading
        | func_heading
        | oot_constructor_head
        | oot_destructor_head
        ;

oot_constructor_head
        : tkConstructor proc_name fp_list fp_directives
        ;

oot_destructor_head
        : tkDestructor proc_name fp_list fp_directives
        ;

new_object_type
        : not_class_reference_type
        | not_object_type
        | not_interface_type
        ;

not_class_reference_type
        : tkClass tkOf not_object_type_identifier
        ;

not_object_type_identifier
        : identifier
        ;

not_object_type
        : tkClass
        | tkClass not_heritage
        | tkClass not_component_list_seq tkEnd
        | tkClass not_heritage not_component_list_seq tkEnd
        ;

not_interface_type
        : tkInterface
        | tkInterface not_heritage
        | tkInterface not_component_list_seq tkEnd
        | tkInterface not_heritage not_component_list_seq tkEnd
        | tkDispinterface
        | tkDispinterface not_heritage
        | tkDispinterface not_component_list_seq tkEnd
        | tkDispinterface not_heritage not_component_list_seq tkEnd
        ;

not_component_list_seq
        : not_component_list
        | not_component_list_seq visibility_specifier not_component_list 
        ;  

not_heritage
        : tkRoundOpen not_object_type_identifier_list tkRoundClose
        ;

not_object_type_identifier_list
        : identifier
        | not_object_type_identifier_list tkComma identifier
        ;                                     

not_component_list
        : not_guid 
        | not_guid not_component_list_1
        | not_guid not_component_list_2
        | not_guid not_component_list_1 not_component_list_2
        ;

not_guid
        : /* empty */ {}
        | tkSquareOpen const_expr tkSquareClose
        ;

not_component_list_1
        : not_field_definition
        | not_component_list_1 not_field_definition
        ;

not_component_list_2
        : not_method_definition
        | not_property_definition
        | not_component_list_2 not_method_definition
        | not_component_list_2 not_property_definition
        ;

not_field_definition
        : not_field_identifier_list tkColon type_ref tkSemiColon
        ;

not_field_identifier_list
        : not_field_identifier
        | not_field_identifier_list tkComma not_field_identifier
        ;

not_field_identifier
        : identifier
        ;

not_method_definition
        : not_method_heading 
        ;

not_method_heading
        : tkClass proc_heading
        | tkClass func_heading
        | func_heading
        | proc_heading
        | not_constructor_heading
        | not_destructor_heading
        ;

not_constructor_heading
        : tkConstructor qualified_identifier fp_list fp_directives
        ;

not_destructor_heading
        : tkDestructor qualified_identifier fp_list fp_directives
        ;                                     

qualified_identifier
        : identifier
        | visibility_specifier  
        | qualified_identifier tkPoint identifier
        | qualified_identifier tkPoint visibility_specifier 
        ;

not_property_definition
        : tkProperty qualified_identifier not_property_interface not_property_specifiers
            tkSemiColon not_array_defaultproperty
        ;                                          

not_array_defaultproperty
        : /* empty */
        | tkDefault tkSemiColon
        ;

not_property_interface
        : /* empty */ {}
        | not_property_parameter_list tkColon qualified_identifier not_property_interface_index
        ;

not_property_interface_index
        : /* empty */ {}
        | tkIndex expr
        ;

not_property_parameter_list
        : /* empty */ {}
        | tkSquareOpen not_parameter_decl_list tkSquareClose
        ;

not_parameter_decl_list
        : not_parameter_decl
        | not_parameter_decl_list tkSemiColon not_parameter_decl
        ;

not_parameter_decl
        : not_parameter_name_list tkColon fptype
        | tkConst not_parameter_name_list tkColon fptype
        | tkVar not_parameter_name_list tkColon fptype
        | tkOut not_parameter_name_list tkColon fptype
        ;

not_parameter_name_list
        : not_parameter_name
        | not_parameter_name_list tkComma not_parameter_name
        ;

not_parameter_name
        : identifier
        ;

not_property_specifiers
        : /* empty */ {}
        | tkReadOnly not_property_specifiers
        | tkWriteOnly not_property_specifiers
        | tkDispid const_expr not_property_specifiers
        | tkDefault const_expr not_property_specifiers
        | tkNodefault not_property_specifiers
        | tkStored const_expr not_property_specifiers
        | tkRead expr not_property_specifiers
        | tkImplements not_object_type_identifier_list not_property_specifiers
        | tkWrite expr not_property_specifiers
        ;


/* Variable declarations: */
var_decl
        : var_name_list tkColon type_ref absolute_clause tkSemiColon
        | var_name_list tkColon type_ref absolute_clause tkEqual var_init_value tkSemiColon
        | var_name_list error error_recovery { yywarning('Ambigious syntax in variable declaration.'); yyerrok; }
        ;                                                                                                      

var_init_value
        : typed_const
        ;

var_name_list
        : var_name
        | var_name_list tkComma var_name
        ;

var_name
        : identifier
        ;

absolute_clause
        : /* empty */ {}
        | tkAbsolute tkInteger tkColon tkInteger
        | tkAbsolute tkHex tkColon tkHex
        | tkAbsolute declared_var_name
        ;

declared_var_name
        : identifier
        ;


/* Method declarations */
constructor_decl
        : not_constructor_heading not_constructor_block_decl
        ;

destructor_decl
        : not_destructor_heading not_constructor_block_decl
        ;

not_constructor_block_decl
        : block
        | external_directr
        | asm_block
        ;

proc_decl
        : proc_heading proc_block
        | tkClass proc_heading proc_block
        ;

func_decl
        : func_heading func_block
        | tkClass func_heading func_block
        ;
  
proc_heading
        : tkProcedure proc_name fp_list fp_directives
        | tkProcedure proc_name tkEqual qualified_identifier tkSemiColon
        | tkProcedure proc_name error error_recovery { yywarning('Ambigious syntax in procedure heading.'); yyerrok; }
        ;

proc_name
        : identifier
        | visibility_specifier
        | proc_name tkPoint identifier
        | proc_name tkPoint visibility_specifier 
        ;

func_heading
        : tkFunction func_name fp_list tkColon fptype fp_directives
        | tkFunction func_name fp_directives
        | tkFunction func_name tkEqual qualified_identifier tkSemiColon
        | tkFunction func_name error error_recovery { yywarning('Ambigious syntax in function heading.'); yyerrok; }  
        ;                                              

fp_directives
        : tkSemiColon  
        | tkSemiColon method_access_directive fp_directives
        | tkSemiColon calling_conventions fp_directives
        | tkSemiColon tkDispid const_expr fp_directives
        | tkSemiColon tkMessage integer_const fp_directives
        ;

func_name
        : identifier
        | visibility_specifier
        | func_name tkPoint identifier
        | func_name tkPoint visibility_specifier
        ;

proc_block
        : proc_block_decl
        | inline_directr tkSemiColon
        ;

func_block
        : proc_block_decl
        | inline_directr tkSemiColon
        ;

proc_block_decl
        : block
        | external_directr
        | asm_block
        | tkForward tkSemiColon
        ;

external_directr
        : tkExternal tkSemiColon
        | tkExternal identifier external_directr_2
        | tkExternal literal external_directr_2
        | tkExternal literal external_directr_2 tkSemiColon
        | tkExternal identifier external_directr_2 tkSemiColon
        ;

external_directr_2  
        : /* empty */ {}
        | tkName identifier
        | tkName literal         
        | tkIndex external_directr_3
        ;

external_directr_3
        : tkInteger
        | tkMinus tkInteger
        ;

asm_block                        
        : impl_decl_sect_list tkAsmBody tkSemiColon
        ;

block   : impl_decl_sect_list compound_stmt tkSemiColon
        ;

fp_list : /* empty */ {}                    
        | tkRoundOpen fp_sect_list tkRoundClose
        ;

fp_sect_list
        : /* empty */ {}
        | fp_sect
        | fp_sect_list tkSemiColon fp_sect
        ;

fp_sect : param_name_list tkColon fptype_new
        | param_name_list
        | tkVar param_name_list tkColon fptype_new
        | tkVar param_name_list
        | tkOut param_name_list tkColon fptype_new
        | tkOut param_name_list
        | tkConst param_name_list tkColon fptype_new
        | tkConst param_name_list
        ;

param_name_list
        : param_name
        | param_name_list tkComma param_name
        ;

param_name
        : identifier
        ;

fptype  : identifier
        | unit_name tkPoint identifier
        ;

fptype_new
        : fptype
        | fptype tkEqual const_expr
        | tkArray tkOf fptype
        | tkArray tkOf tkConst
        ;

        
/* Statements */
stmt    : unlabelled_stmt
        | label_name tkColon unlabelled_stmt
        ;

unlabelled_stmt
        : /* empty */ {}
        | assignment
        | proc_call
        | goto_stmt
        | compound_stmt
        | if_stmt
        | case_stmt
        | repeat_stmt
        | while_stmt
        | for_stmt
        | with_stmt
        | asm_stmt
        | inline_directr
        | inherited_message
        | try_stmt
        | raise_stmt       
        ;

assignment
        : var_reference tkAssign expr
        ;

proc_call                          
        : var_reference
        ;

goto_stmt
        : tkGoto label_name
        ;

compound_stmt
        : tkBegin stmt_list tkEnd
        ;

stmt_list
        : stmt
        | stmt_list tkSemiColon stmt
        ;
                                                
if_stmt : tkIf expr if_then_else_branch
        ;

if_then_else_branch
        : tkThen then_branch
        | tkThen then_branch tkElse else_branch
        ;

then_branch
        : stmt
        ;

else_branch
        : stmt
        ;

case_stmt
        : tkCase expr tkOf case_list else_case tkEnd
        ;

case_list
        : case_item
        | case_list tkSemiColon case_item
        ;

case_item
        : /* empty */ {}
        | case_label_list tkColon stmt
        ;

case_label_list
        : case_label
        | case_label_list tkComma case_label
        ;

case_label
        : const_expr
        | const_expr tkDotDot const_expr
        ;

else_case
        : /* empty */ {}
        | tkElse stmt_list
        ;

repeat_stmt
        : tkRepeat stmt_list tkUntil expr
        ;

while_stmt
        : tkWhile expr tkDo stmt
        ;

for_stmt
        : tkFor identifier tkAssign expr for_to        
        ;

for_to
        : tkTo expr tkDo stmt
        | tkDownto expr tkDo stmt
        ;       

with_stmt
        : tkWith expr_list tkDo stmt
        ;

inherited_message
        : tkInherited
        ;

try_stmt
        : tkTry stmt_list try_handler  
        ;

try_handler
        : tkFinally stmt_list tkEnd
        | tkExcept exception_block tkEnd
        ;

exception_block
        : exception_handler_list exception_block_else_branch
        | exception_handler_list tkSemiColon exception_block_else_branch
        | stmt_list
        ;

exception_handler_list
        : exception_handler
        | exception_handler_list tkSemiColon exception_handler
        ;

exception_block_else_branch
        : /* empty */ {}
        | tkElse stmt_list
        ;

exception_handler
        : tkOn exception_identifier tkDo stmt
        ;

exception_identifier
        : exception_class_type_identifier
        | exception_variable tkColon exception_class_type_identifier
        ;

exception_class_type_identifier
        : identifier
        ;

exception_variable
        : identifier
        ;

raise_stmt
        : tkRaise 
        | tkRaise expr
        | tkRaise expr tkAt expr
        ;

asm_stmt
        : tkAsmBody
        ;                 


/* Expressions: */
expr_list
        : expr
        | expr_list tkComma expr
        ;

expr    : simple_expr            
        | simple_expr relop expr  
        | simple_expr tkColon simple_expr
        | simple_expr tkColon simple_expr tkColon simple_expr
        ;


relop   : tkEqual | tkNotEqual | tkLower | tkGreater
        | tkLowerEqual | tkGreaterEqual | tkIn | tkIs
        ;
                               
simple_expr
        : term
        | simple_expr addop term
        ;

addop   : tkPlus | tkMinus | tkOr | tkXor
        ;

term    : factor              
        | term mulop factor 
        ;

mulop   : tkStar | tkSlash | tkDiv | tkMod | tkShl | tkShr | tkAnd | tkAs
        ;

factor
        : unsigned_number
        | literal
        | tkNil
        | tkSquareOpen elem_list tkSquareClose
        | tkNot factor
        | sign factor
        | tkDeref factor
        | var_reference
        ;

var_reference
        : var_address variable
        | variable
        ;

var_address
        : tkAddressOf
        | var_address tkAddressOf
        ;

variable
        : identifier
        | tkInherited identifier
        | tkRoundOpen expr tkRoundClose
        | tkRoundOpen tkRoundClose
        | variable var_specifiers
        ;

var_specifiers
        : tkSquareOpen expr_list tkSquareClose
        | tkSquareOpen tkSquareClose
        | tkRoundOpen expr_list tkRoundClose
        | tkRoundOpen tkRoundClose
        | tkPoint identifier
        | tkDeref
        ;

elem_list
        : /* empty */ {}
        | elem_list1
        ;

elem_list1
        : elem
        | elem_list1 tkComma elem
        ;
                         
elem    : expr
        | expr tkDotDot expr
        ;                                                       

/* Support for obsolete inline_directive */
inline_directr                                      
        : tkInline tkRoundOpen inline_element tkRoundClose
        ;

inline_element
        : inline_param
        | inline_element tkSlash inline_param
        ;

inline_param
        : tkLower inline_const
        | tkGreater inline_const
        | inline_param_variable
        ;

inline_param_variable
        : var_reference  
        | inline_param_variable sign inline_const
        | tkHex
        ;                     

inline_const
        : const_factor
        ;



/* Terminal rules that depend only upon tokens or themselves */
literal : tkStringLiteral
        | tkAsciiChar
        | tkStringLiteral literal
        | tkAsciiChar literal
        ;

integer_const
        : sign tkInteger
        | tkInteger
        | sign tkHex
        | tkHex
        | identifier
        | sign identifier
        ;

real_type_name
        : tkReal48 | tkReal | tkSingle | tkDouble | tkExtended | tkCurrency | tkComp
        ;

ord_type_name
        : tkShortInt | tkSmallInt | tkOrdInteger | tkByte | tkLongInt
        | tkInt64 | tkWord| tkBoolean | tkChar | tkWideChar | tkLongWord
        | tkPChar | tkCardinal
        ;

variant_type_name
        : tkVariant | tkOleVariant
        ;

string_type_name
        : tkString | tkAnsiString | tkWideString
        ;

calling_conventions
        : tkRegister | tkPascal | tkCdecl | tkSafecall
        | tkNear | tkFar | tkStdcall | tkResident | tkExport | tkAssembler
        ;

property_specifier_directives
        : tkDefault | tkRead | tkWrite | tkStored | tkNodefault
        | tkImplements | tkWriteOnly | tkReadOnly | tkDispid
        ;

method_access_directive
        : tkAbstract | tkAutomated | tkDynamic | tkOverload
        | tkOverride | tkReintroduce | tkVirtual
        ;

non_reserved
        : tkAt | tkAbsolute | tkOn | tkName | tkIndex | tkMessage
        | tkContains | tkRequires | tkForward | tkOut
        ;

visibility_specifier
        : tkPublished | tkPublic | tkProtected | tkPrivate
        ;

other   : tkPackage
        | tkUnit
        | tkLibrary
        | tkProgram 
        | tkExternal
        ;

identifier
        : tkIdentifier
        | real_type_name
        | ord_type_name
        | variant_type_name                                           
        | string_type_name
        | method_access_directive
        | calling_conventions
        | property_specifier_directives
        | non_reserved
        | other
        ;

%%

