%{
{
	Code Linguine Source Code Parsing/Query Library
	Copyright (C) 2000-2005 Pavel Simakov
	http://www.softwaresecretweapons.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
}

{     DO NOT EDIT BY HAND! THIS FILE IS AUTO GENERATED!       }
%}

%%

%{

  procedure OYReturn(const Token : Integer);
  begin
    yyreturn(Token);
  end;

  procedure OYParseBinary;
  var
    c : Char;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        '}' : begin
          break;      
        end;
        else begin
          yytext := yytext + c;
        end;
      end;
    until false;
    OYReturn(tkBinary);
  end;

  procedure OYParseLiteral;
  var
    c : Char;
  begin
    repeat
      c := get_char;
      if c = #0 then exit;
      yytext := yytext + c;
      case c of
        '''' : begin
          yytext := yytext + c;
          c := get_char;
          case c of
            '''' : begin
              yytext := yytext + c;
            end;
            else begin
              unget_char(c);
              break;
            end;
          end;
        end;
      end;
    until false;
    OYReturn(tkStringLiteral);
  end;

%}

"'"     OYParseLiteral;
"{"     OYParseBinary;
[oO][bB][jJ][eE][cC][tT]
        OYReturn(tkObject);
[iI][nN][lL][iI][nN][eE]
        OYReturn(tkInline);
[iI][nN][hH][eE][rR][iI][tT][eE][dD]
        OYReturn(tkInherited);       
[eE][nN][dD]                           
        OYReturn(tkEnd);
[0-9]+([eE][0-9]+)?
        OYReturn(tkInteger);
[_a-zA-Z]([_a-zA-Z0-9])*
        OYReturn(tkIdentifier);
[0-9]+"."[0-9]+([eE][+-]*[0-9]+)?
        OYReturn(tkFloat);
[0-9]+"."/[^\.]                 
        OYReturn(tkFloat);
[#][0-9]+                                
        OYReturn(tkAsciiChar);
"-"			OYReturn(tkMinus);
"["			OYReturn(tkSquareOpen);
"]"			OYReturn(tkSquareClose);
"("			OYReturn(tkRoundOpen);
")"			OYReturn(tkRoundClose);
"-"			OYReturn(tkMinus);
">"			OYReturn(tkGreater);
"<"			OYReturn(tkLower);
"="			OYReturn(tkEqual);
":"     OYReturn(tkColon);
";"     OYReturn(tkSemiColon);
"."     OYReturn(tkPoint);
","     OYReturn(tkComma);
[ ]     OYReturn(tkSpace);
[\n]    OYReturn(tkCRLF);
[\f]    OYReturn(tkCRLF);
[\r]    OYReturn(tkCRLF);
.			  OYReturn(tkUnknown);


