{
	Code Linguine Source Code Parsing/Query Library
	Copyright (C) 2000-2005 Pavel Simakov
	http://www.softwaresecretweapons.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
}

type
  TTemplatedParser = class(TOYParser)
  protected
    procedure yyaction ( yyruleno : Integer ); override;
  public
    function yyparse : Boolean; override;
    class function yyruleId(Index : Word) : Integer; override;
    class function yyruleName(Index : Word) : String; override;
    class function yyruleBody(Index : Word) : String; override;
    class function yyruleCount : Word; override;
    class function yyruleLen(Index : Word) : Integer; override;
    class function yytokenId(Index : Word) : Integer; override;
    class function yytokenName(Index : Word) : String; override;
    class function yytokenBody(Index : Word) : String; override;
    class function yytokenCount : Word; override;
  end;

const tkObject = 257;
const tkIdentifier = 258;
const tkInherited = 259;
const tkInline = 260;
const tkEnd = 261;
const tkStringLiteral = 262;
const tkAsciiChar = 263;
const tkSquareOpen = 264;
const tkSquareClose = 265;
const tkRoundOpen = 266;
const tkRoundClose = 267;
const tkBinary = 268;
const tkInteger = 269;
const tkFloat = 270;
const tkColon = 271;
const tkSemiColon = 272;
const tkEqual = 273;
const tkMinus = 274;
const tkGreater = 275;
const tkLower = 276;
const tkPoint = 277;
const tkComma = 278;
const tkCRLF = 279;
const tkSpace = 280;
const tkJunk = 281;
const tkUnknown = 282;


implementation

(* local definitions: *)
procedure TTemplatedParser.yyaction ( yyruleno : Integer );
begin
  (* actions: *)
  case yyruleno of
   1 : begin
         yyval := yyv[yysp-0];
       end;
   2 : begin
         yyval := yyv[yysp-3];
       end;
   3 : begin
         yyval := yyv[yysp-2];
       end;
   4 : begin
         yyval := yyv[yysp-5];
       end;
   5 : begin
         yyval := yyv[yysp-8];
       end;
   6 : begin
         yyval := yyv[yysp-4];
       end;
   7 : begin
         yyval := yyv[yysp-0];
       end;
   8 : begin
         yyval := yyv[yysp-0];
       end;
   9 : begin
         yyval := yyv[yysp-0];
       end;
  10 : begin
         yyval := yyv[yysp-0];
       end;
  11 : begin
         yyval := yyv[yysp-2];
       end;
  12 : begin
         yyval := yyv[yysp-3];
       end;
  13 : begin
         yyval := yyv[yysp-1];
       end;
  14 : begin
         yyval := yyv[yysp-0];
       end;
  15 : begin
         yyval := yyv[yysp-2];
       end;
  16 : begin
         yyval := yyv[yysp-1];
       end;
  17 : begin
         yyval := yyv[yysp-2];
       end;
  18 : begin
         yyval := yyv[yysp-2];
       end;
  19 : begin
         yyval := yyv[yysp-0];
       end;
  20 : begin
         yyval := yyv[yysp-2];
       end;
  21 : begin
         yyval := yyv[yysp-3];
       end;
  22 : begin
         yyval := yyv[yysp-2];
       end;
  23 : begin
         yyval := yyv[yysp-1];
       end;
  24 : begin
         yyval := yyv[yysp-3];
       end;
  25 : begin
         yyval := yyv[yysp-2];
       end;
  26 : begin
         
       end;
  27 : begin
         yyval := yyv[yysp-0];
       end;
  28 : begin
         yyval := yyv[yysp-2];
       end;
  29 : begin
         yyval := yyv[yysp-0];
       end;
  30 : begin
         yyval := yyv[yysp-1];
       end;
  31 : begin
         yyval := yyv[yysp-0];
       end;
  32 : begin
         yyval := yyv[yysp-0];
       end;
  33 : begin
         yyval := yyv[yysp-1];
       end;
  34 : begin
         yyval := yyv[yysp-1];
       end;
  35 : begin
         yyval := yyv[yysp-0];
       end;
  36 : begin
         yyval := yyv[yysp-1];
       end;
  37 : begin
         yyval := yyv[yysp-1];
       end;
  38 : begin
         yyval := yyv[yysp-0];
       end;
  39 : begin
         yyval := yyv[yysp-0];
       end;
  40 : begin
         yyval := yyv[yysp-0];
       end;
  41 : begin
         yyval := yyv[yysp-0];
       end;
  42 : begin
         yyval := yyv[yysp-2];
       end;
  43 : begin
         yyval := yyv[yysp-1];
       end;
  44 : begin
         yyval := yyv[yysp-1];
       end;
  45 : begin
         yyval := yyv[yysp-0];
       end;
  46 : begin
         yyval := yyv[yysp-0];
       end;
  47 : begin
         yyval := yyv[yysp-0];
       end;
  48 : begin
         yyval := yyv[yysp-0];
       end;
  49 : begin
         yyval := yyv[yysp-0];
       end;
  50 : begin
         yyval := yyv[yysp-2];
       end;
  end;
end(*yyaction*);

(* parse table: *)

type YYARec = record
                sym, act : Integer;
              end;
     YYRRec = record
                len, sym : Integer;
                name, body : String;
              end;

const

yynacts   = 317;
yyngotos  = 79;
yynstates = 87;
yynrules  = 50;

yya : array [1..yynacts] of YYARec = (
{ 0: }
  ( sym: 257; act: 4 ),
  ( sym: 259; act: 5 ),
  ( sym: 260; act: 6 ),
{ 1: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
{ 2: }
{ 3: }
  ( sym: 0; act: 0 ),
{ 4: }
{ 5: }
{ 6: }
{ 7: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 19 ),
  ( sym: 271; act: 20 ),
  ( sym: 277; act: 21 ),
{ 8: }
{ 9: }
{ 10: }
{ 11: }
{ 12: }
{ 13: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 24 ),
{ 14: }
  ( sym: 273; act: 25 ),
  ( sym: 277; act: 21 ),
{ 15: }
{ 16: }
  ( sym: 257; act: -7 ),
  ( sym: 258; act: -7 ),
  ( sym: 259; act: -7 ),
  ( sym: 260; act: -7 ),
  ( sym: 261; act: -7 ),
  ( sym: 273; act: -46 ),
  ( sym: 277; act: -46 ),
{ 17: }
  ( sym: 257; act: -9 ),
  ( sym: 258; act: -9 ),
  ( sym: 259; act: -9 ),
  ( sym: 260; act: -9 ),
  ( sym: 261; act: -9 ),
  ( sym: 273; act: -47 ),
  ( sym: 277; act: -47 ),
{ 18: }
  ( sym: 257; act: -8 ),
  ( sym: 258; act: -8 ),
  ( sym: 259; act: -8 ),
  ( sym: 260; act: -8 ),
  ( sym: 261; act: -8 ),
  ( sym: 273; act: -48 ),
  ( sym: 277; act: -48 ),
{ 19: }
  ( sym: 0; act: -3 ),
  ( sym: 257; act: -3 ),
  ( sym: 258; act: -3 ),
  ( sym: 259; act: -3 ),
  ( sym: 260; act: -3 ),
  ( sym: 261; act: -3 ),
  ( sym: 273; act: -49 ),
  ( sym: 277; act: -49 ),
{ 20: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
{ 21: }
  ( sym: 258; act: 27 ),
{ 22: }
  ( sym: 273; act: 28 ),
  ( sym: 277; act: 21 ),
{ 23: }
{ 24: }
  ( sym: 0; act: -2 ),
  ( sym: 257; act: -2 ),
  ( sym: 258; act: -2 ),
  ( sym: 259; act: -2 ),
  ( sym: 260; act: -2 ),
  ( sym: 261; act: -2 ),
  ( sym: 273; act: -49 ),
  ( sym: 277; act: -49 ),
{ 25: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
  ( sym: 262; act: 34 ),
  ( sym: 263; act: 35 ),
  ( sym: 264; act: 36 ),
  ( sym: 266; act: 37 ),
  ( sym: 268; act: 38 ),
  ( sym: 269; act: 39 ),
  ( sym: 270; act: 40 ),
  ( sym: 274; act: 41 ),
  ( sym: 276; act: 42 ),
{ 26: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 44 ),
  ( sym: 264; act: 45 ),
  ( sym: 277; act: 21 ),
{ 27: }
{ 28: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
  ( sym: 262; act: 34 ),
  ( sym: 263; act: 35 ),
  ( sym: 264; act: 36 ),
  ( sym: 266; act: 37 ),
  ( sym: 268; act: 38 ),
  ( sym: 269; act: 39 ),
  ( sym: 270; act: 40 ),
  ( sym: 274; act: 41 ),
  ( sym: 276; act: 42 ),
{ 29: }
  ( sym: 262; act: 48 ),
  ( sym: 263; act: 49 ),
  ( sym: 257; act: -39 ),
  ( sym: 258; act: -39 ),
  ( sym: 259; act: -39 ),
  ( sym: 260; act: -39 ),
  ( sym: 261; act: -39 ),
  ( sym: 266; act: -39 ),
  ( sym: 267; act: -39 ),
  ( sym: 268; act: -39 ),
  ( sym: 269; act: -39 ),
  ( sym: 270; act: -39 ),
  ( sym: 274; act: -39 ),
{ 30: }
  ( sym: 269; act: 50 ),
  ( sym: 270; act: 51 ),
{ 31: }
{ 32: }
{ 33: }
  ( sym: 277; act: 21 ),
  ( sym: 257; act: -38 ),
  ( sym: 258; act: -38 ),
  ( sym: 259; act: -38 ),
  ( sym: 260; act: -38 ),
  ( sym: 261; act: -38 ),
  ( sym: 262; act: -38 ),
  ( sym: 263; act: -38 ),
  ( sym: 266; act: -38 ),
  ( sym: 267; act: -38 ),
  ( sym: 268; act: -38 ),
  ( sym: 269; act: -38 ),
  ( sym: 270; act: -38 ),
  ( sym: 274; act: -38 ),
{ 34: }
{ 35: }
{ 36: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
  ( sym: 265; act: -26 ),
  ( sym: 278; act: -26 ),
{ 37: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
  ( sym: 262; act: 34 ),
  ( sym: 263; act: 35 ),
  ( sym: 266; act: 57 ),
  ( sym: 268; act: 38 ),
  ( sym: 269; act: 39 ),
  ( sym: 270; act: 40 ),
  ( sym: 274; act: 41 ),
{ 38: }
{ 39: }
{ 40: }
{ 41: }
  ( sym: 269; act: 58 ),
  ( sym: 270; act: 59 ),
{ 42: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
  ( sym: 275; act: 62 ),
{ 43: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 63 ),
{ 44: }
  ( sym: 0; act: -6 ),
  ( sym: 257; act: -6 ),
  ( sym: 258; act: -6 ),
  ( sym: 259; act: -6 ),
  ( sym: 260; act: -6 ),
  ( sym: 261; act: -6 ),
  ( sym: 273; act: -49 ),
  ( sym: 277; act: -49 ),
{ 45: }
  ( sym: 269; act: 64 ),
{ 46: }
{ 47: }
  ( sym: 262; act: 65 ),
{ 48: }
{ 49: }
{ 50: }
{ 51: }
{ 52: }
  ( sym: 265; act: 66 ),
  ( sym: 278; act: 67 ),
{ 53: }
  ( sym: 277; act: 21 ),
  ( sym: 265; act: -27 ),
  ( sym: 278; act: -27 ),
{ 54: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
  ( sym: 262; act: 34 ),
  ( sym: 263; act: 35 ),
  ( sym: 268; act: 38 ),
  ( sym: 269; act: 39 ),
  ( sym: 270; act: 40 ),
  ( sym: 274; act: 41 ),
  ( sym: 266; act: -19 ),
  ( sym: 267; act: -19 ),
{ 55: }
  ( sym: 266; act: 69 ),
  ( sym: 267; act: 70 ),
{ 56: }
{ 57: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
  ( sym: 262; act: 34 ),
  ( sym: 263; act: 35 ),
  ( sym: 266; act: 57 ),
  ( sym: 268; act: 38 ),
  ( sym: 269; act: 39 ),
  ( sym: 270; act: 40 ),
  ( sym: 274; act: 41 ),
{ 58: }
{ 59: }
{ 60: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
  ( sym: 275; act: 73 ),
{ 61: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 75 ),
  ( sym: 277; act: 21 ),
{ 62: }
{ 63: }
  ( sym: 0; act: -4 ),
  ( sym: 257; act: -4 ),
  ( sym: 258; act: -4 ),
  ( sym: 259; act: -4 ),
  ( sym: 260; act: -4 ),
  ( sym: 261; act: -4 ),
  ( sym: 273; act: -49 ),
  ( sym: 277; act: -49 ),
{ 64: }
  ( sym: 265; act: 76 ),
{ 65: }
{ 66: }
{ 67: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
{ 68: }
{ 69: }
  ( sym: 257; act: 8 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 10 ),
  ( sym: 260; act: 11 ),
  ( sym: 261; act: 12 ),
  ( sym: 262; act: 34 ),
  ( sym: 263; act: 35 ),
  ( sym: 266; act: 57 ),
  ( sym: 268; act: 38 ),
  ( sym: 269; act: 39 ),
  ( sym: 270; act: 40 ),
  ( sym: 274; act: 41 ),
{ 70: }
{ 71: }
  ( sym: 266; act: 69 ),
  ( sym: 267; act: 79 ),
{ 72: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 81 ),
  ( sym: 277; act: 21 ),
{ 73: }
{ 74: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 82 ),
{ 75: }
  ( sym: 257; act: -23 ),
  ( sym: 258; act: -23 ),
  ( sym: 259; act: -23 ),
  ( sym: 260; act: -23 ),
  ( sym: 261; act: -23 ),
  ( sym: 275; act: -23 ),
  ( sym: 273; act: -49 ),
  ( sym: 277; act: -49 ),
{ 76: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 12 ),
{ 77: }
  ( sym: 277; act: 21 ),
  ( sym: 265; act: -28 ),
  ( sym: 278; act: -28 ),
{ 78: }
  ( sym: 266; act: 69 ),
  ( sym: 267; act: 84 ),
{ 79: }
{ 80: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 85 ),
{ 81: }
  ( sym: 257; act: -25 ),
  ( sym: 258; act: -25 ),
  ( sym: 259; act: -25 ),
  ( sym: 260; act: -25 ),
  ( sym: 261; act: -25 ),
  ( sym: 275; act: -25 ),
  ( sym: 273; act: -49 ),
  ( sym: 277; act: -49 ),
{ 82: }
  ( sym: 257; act: -22 ),
  ( sym: 258; act: -22 ),
  ( sym: 259; act: -22 ),
  ( sym: 260; act: -22 ),
  ( sym: 261; act: -22 ),
  ( sym: 275; act: -22 ),
  ( sym: 273; act: -49 ),
  ( sym: 277; act: -49 ),
{ 83: }
  ( sym: 257; act: 16 ),
  ( sym: 258; act: 9 ),
  ( sym: 259; act: 17 ),
  ( sym: 260; act: 18 ),
  ( sym: 261; act: 86 ),
{ 84: }
{ 85: }
  ( sym: 257; act: -24 ),
  ( sym: 258; act: -24 ),
  ( sym: 259; act: -24 ),
  ( sym: 260; act: -24 ),
  ( sym: 261; act: -24 ),
  ( sym: 275; act: -24 ),
  ( sym: 273; act: -49 ),
  ( sym: 277; act: -49 ),
{ 86: }
  ( sym: 0; act: -5 ),
  ( sym: 257; act: -5 ),
  ( sym: 258; act: -5 ),
  ( sym: 259; act: -5 ),
  ( sym: 260; act: -5 ),
  ( sym: 261; act: -5 ),
  ( sym: 273; act: -49 ),
  ( sym: 277; act: -49 )
);

yyg : array [1..yyngotos] of YYARec = (
{ 0: }
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 2 ),
  ( sym: -2; act: 3 ),
{ 1: }
  ( sym: -5; act: 7 ),
{ 2: }
{ 3: }
{ 4: }
{ 5: }
{ 6: }
{ 7: }
  ( sym: -6; act: 13 ),
  ( sym: -5; act: 14 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 15 ),
{ 8: }
{ 9: }
{ 10: }
{ 11: }
{ 12: }
{ 13: }
  ( sym: -5; act: 22 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 23 ),
{ 14: }
{ 15: }
{ 16: }
{ 17: }
{ 18: }
{ 19: }
{ 20: }
  ( sym: -5; act: 26 ),
{ 21: }
{ 22: }
{ 23: }
{ 24: }
{ 25: }
  ( sym: -14; act: 29 ),
  ( sym: -13; act: 30 ),
  ( sym: -8; act: 31 ),
  ( sym: -7; act: 32 ),
  ( sym: -5; act: 33 ),
{ 26: }
  ( sym: -6; act: 43 ),
  ( sym: -5; act: 14 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 15 ),
{ 27: }
{ 28: }
  ( sym: -14; act: 29 ),
  ( sym: -13; act: 30 ),
  ( sym: -8; act: 31 ),
  ( sym: -7; act: 46 ),
  ( sym: -5; act: 33 ),
{ 29: }
  ( sym: -13; act: 47 ),
{ 30: }
{ 31: }
{ 32: }
{ 33: }
{ 34: }
{ 35: }
{ 36: }
  ( sym: -10; act: 52 ),
  ( sym: -5; act: 53 ),
{ 37: }
  ( sym: -14; act: 29 ),
  ( sym: -13; act: 30 ),
  ( sym: -12; act: 54 ),
  ( sym: -11; act: 55 ),
  ( sym: -8; act: 56 ),
  ( sym: -5; act: 33 ),
{ 38: }
{ 39: }
{ 40: }
{ 41: }
{ 42: }
  ( sym: -9; act: 60 ),
  ( sym: -5; act: 61 ),
{ 43: }
  ( sym: -5; act: 22 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 23 ),
{ 44: }
{ 45: }
{ 46: }
{ 47: }
{ 48: }
{ 49: }
{ 50: }
{ 51: }
{ 52: }
{ 53: }
{ 54: }
  ( sym: -14; act: 29 ),
  ( sym: -13; act: 30 ),
  ( sym: -8; act: 68 ),
  ( sym: -5; act: 33 ),
{ 55: }
{ 56: }
{ 57: }
  ( sym: -14; act: 29 ),
  ( sym: -13; act: 30 ),
  ( sym: -12; act: 54 ),
  ( sym: -11; act: 71 ),
  ( sym: -8; act: 56 ),
  ( sym: -5; act: 33 ),
{ 58: }
{ 59: }
{ 60: }
  ( sym: -5; act: 72 ),
{ 61: }
  ( sym: -6; act: 74 ),
  ( sym: -5; act: 14 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 15 ),
{ 62: }
{ 63: }
{ 64: }
{ 65: }
{ 66: }
{ 67: }
  ( sym: -5; act: 77 ),
{ 68: }
{ 69: }
  ( sym: -14; act: 29 ),
  ( sym: -13; act: 30 ),
  ( sym: -12; act: 54 ),
  ( sym: -11; act: 78 ),
  ( sym: -8; act: 56 ),
  ( sym: -5; act: 33 ),
{ 70: }
{ 71: }
{ 72: }
  ( sym: -6; act: 80 ),
  ( sym: -5; act: 14 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 15 ),
{ 73: }
{ 74: }
  ( sym: -5; act: 22 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 23 ),
{ 75: }
{ 76: }
  ( sym: -6; act: 83 ),
  ( sym: -5; act: 14 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 15 ),
{ 77: }
{ 78: }
{ 79: }
{ 80: }
  ( sym: -5; act: 22 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 23 ),
{ 81: }
{ 82: }
{ 83: }
  ( sym: -5; act: 22 ),
  ( sym: -4; act: 1 ),
  ( sym: -3; act: 23 )
{ 84: }
{ 85: }
{ 86: }
);

yyd : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } -1,
{ 3: } 0,
{ 4: } -7,
{ 5: } -9,
{ 6: } -8,
{ 7: } 0,
{ 8: } -46,
{ 9: } -45,
{ 10: } -47,
{ 11: } -48,
{ 12: } -49,
{ 13: } 0,
{ 14: } 0,
{ 15: } -10,
{ 16: } 0,
{ 17: } 0,
{ 18: } 0,
{ 19: } 0,
{ 20: } 0,
{ 21: } 0,
{ 22: } 0,
{ 23: } -13,
{ 24: } 0,
{ 25: } 0,
{ 26: } 0,
{ 27: } -50,
{ 28: } 0,
{ 29: } 0,
{ 30: } 0,
{ 31: } -14,
{ 32: } -11,
{ 33: } 0,
{ 34: } -40,
{ 35: } -41,
{ 36: } 0,
{ 37: } 0,
{ 38: } -31,
{ 39: } -32,
{ 40: } -35,
{ 41: } 0,
{ 42: } 0,
{ 43: } 0,
{ 44: } 0,
{ 45: } 0,
{ 46: } -12,
{ 47: } 0,
{ 48: } -44,
{ 49: } -43,
{ 50: } -34,
{ 51: } -37,
{ 52: } 0,
{ 53: } 0,
{ 54: } 0,
{ 55: } 0,
{ 56: } -29,
{ 57: } 0,
{ 58: } -33,
{ 59: } -36,
{ 60: } 0,
{ 61: } 0,
{ 62: } -16,
{ 63: } 0,
{ 64: } 0,
{ 65: } -42,
{ 66: } -17,
{ 67: } 0,
{ 68: } -30,
{ 69: } 0,
{ 70: } -18,
{ 71: } 0,
{ 72: } 0,
{ 73: } -15,
{ 74: } 0,
{ 75: } 0,
{ 76: } 0,
{ 77: } 0,
{ 78: } 0,
{ 79: } -20,
{ 80: } 0,
{ 81: } 0,
{ 82: } 0,
{ 83: } 0,
{ 84: } -21,
{ 85: } 0,
{ 86: } 0
);

yyal : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 4,
{ 2: } 9,
{ 3: } 9,
{ 4: } 10,
{ 5: } 10,
{ 6: } 10,
{ 7: } 10,
{ 8: } 17,
{ 9: } 17,
{ 10: } 17,
{ 11: } 17,
{ 12: } 17,
{ 13: } 17,
{ 14: } 22,
{ 15: } 24,
{ 16: } 24,
{ 17: } 31,
{ 18: } 38,
{ 19: } 45,
{ 20: } 53,
{ 21: } 58,
{ 22: } 59,
{ 23: } 61,
{ 24: } 61,
{ 25: } 69,
{ 26: } 83,
{ 27: } 90,
{ 28: } 90,
{ 29: } 104,
{ 30: } 117,
{ 31: } 119,
{ 32: } 119,
{ 33: } 119,
{ 34: } 133,
{ 35: } 133,
{ 36: } 133,
{ 37: } 140,
{ 38: } 152,
{ 39: } 152,
{ 40: } 152,
{ 41: } 152,
{ 42: } 154,
{ 43: } 160,
{ 44: } 165,
{ 45: } 173,
{ 46: } 174,
{ 47: } 174,
{ 48: } 175,
{ 49: } 175,
{ 50: } 175,
{ 51: } 175,
{ 52: } 175,
{ 53: } 177,
{ 54: } 180,
{ 55: } 193,
{ 56: } 195,
{ 57: } 195,
{ 58: } 207,
{ 59: } 207,
{ 60: } 207,
{ 61: } 213,
{ 62: } 219,
{ 63: } 219,
{ 64: } 227,
{ 65: } 228,
{ 66: } 228,
{ 67: } 228,
{ 68: } 233,
{ 69: } 233,
{ 70: } 245,
{ 71: } 245,
{ 72: } 247,
{ 73: } 253,
{ 74: } 253,
{ 75: } 258,
{ 76: } 266,
{ 77: } 271,
{ 78: } 274,
{ 79: } 276,
{ 80: } 276,
{ 81: } 281,
{ 82: } 289,
{ 83: } 297,
{ 84: } 302,
{ 85: } 302,
{ 86: } 310
);

yyah : array [0..yynstates-1] of Integer = (
{ 0: } 3,
{ 1: } 8,
{ 2: } 8,
{ 3: } 9,
{ 4: } 9,
{ 5: } 9,
{ 6: } 9,
{ 7: } 16,
{ 8: } 16,
{ 9: } 16,
{ 10: } 16,
{ 11: } 16,
{ 12: } 16,
{ 13: } 21,
{ 14: } 23,
{ 15: } 23,
{ 16: } 30,
{ 17: } 37,
{ 18: } 44,
{ 19: } 52,
{ 20: } 57,
{ 21: } 58,
{ 22: } 60,
{ 23: } 60,
{ 24: } 68,
{ 25: } 82,
{ 26: } 89,
{ 27: } 89,
{ 28: } 103,
{ 29: } 116,
{ 30: } 118,
{ 31: } 118,
{ 32: } 118,
{ 33: } 132,
{ 34: } 132,
{ 35: } 132,
{ 36: } 139,
{ 37: } 151,
{ 38: } 151,
{ 39: } 151,
{ 40: } 151,
{ 41: } 153,
{ 42: } 159,
{ 43: } 164,
{ 44: } 172,
{ 45: } 173,
{ 46: } 173,
{ 47: } 174,
{ 48: } 174,
{ 49: } 174,
{ 50: } 174,
{ 51: } 174,
{ 52: } 176,
{ 53: } 179,
{ 54: } 192,
{ 55: } 194,
{ 56: } 194,
{ 57: } 206,
{ 58: } 206,
{ 59: } 206,
{ 60: } 212,
{ 61: } 218,
{ 62: } 218,
{ 63: } 226,
{ 64: } 227,
{ 65: } 227,
{ 66: } 227,
{ 67: } 232,
{ 68: } 232,
{ 69: } 244,
{ 70: } 244,
{ 71: } 246,
{ 72: } 252,
{ 73: } 252,
{ 74: } 257,
{ 75: } 265,
{ 76: } 270,
{ 77: } 273,
{ 78: } 275,
{ 79: } 275,
{ 80: } 280,
{ 81: } 288,
{ 82: } 296,
{ 83: } 301,
{ 84: } 301,
{ 85: } 309,
{ 86: } 317
);

yygl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 4,
{ 2: } 5,
{ 3: } 5,
{ 4: } 5,
{ 5: } 5,
{ 6: } 5,
{ 7: } 5,
{ 8: } 9,
{ 9: } 9,
{ 10: } 9,
{ 11: } 9,
{ 12: } 9,
{ 13: } 9,
{ 14: } 12,
{ 15: } 12,
{ 16: } 12,
{ 17: } 12,
{ 18: } 12,
{ 19: } 12,
{ 20: } 12,
{ 21: } 13,
{ 22: } 13,
{ 23: } 13,
{ 24: } 13,
{ 25: } 13,
{ 26: } 18,
{ 27: } 22,
{ 28: } 22,
{ 29: } 27,
{ 30: } 28,
{ 31: } 28,
{ 32: } 28,
{ 33: } 28,
{ 34: } 28,
{ 35: } 28,
{ 36: } 28,
{ 37: } 30,
{ 38: } 36,
{ 39: } 36,
{ 40: } 36,
{ 41: } 36,
{ 42: } 36,
{ 43: } 38,
{ 44: } 41,
{ 45: } 41,
{ 46: } 41,
{ 47: } 41,
{ 48: } 41,
{ 49: } 41,
{ 50: } 41,
{ 51: } 41,
{ 52: } 41,
{ 53: } 41,
{ 54: } 41,
{ 55: } 45,
{ 56: } 45,
{ 57: } 45,
{ 58: } 51,
{ 59: } 51,
{ 60: } 51,
{ 61: } 52,
{ 62: } 56,
{ 63: } 56,
{ 64: } 56,
{ 65: } 56,
{ 66: } 56,
{ 67: } 56,
{ 68: } 57,
{ 69: } 57,
{ 70: } 63,
{ 71: } 63,
{ 72: } 63,
{ 73: } 67,
{ 74: } 67,
{ 75: } 70,
{ 76: } 70,
{ 77: } 74,
{ 78: } 74,
{ 79: } 74,
{ 80: } 74,
{ 81: } 77,
{ 82: } 77,
{ 83: } 77,
{ 84: } 80,
{ 85: } 80,
{ 86: } 80
);

yygh : array [0..yynstates-1] of Integer = (
{ 0: } 3,
{ 1: } 4,
{ 2: } 4,
{ 3: } 4,
{ 4: } 4,
{ 5: } 4,
{ 6: } 4,
{ 7: } 8,
{ 8: } 8,
{ 9: } 8,
{ 10: } 8,
{ 11: } 8,
{ 12: } 8,
{ 13: } 11,
{ 14: } 11,
{ 15: } 11,
{ 16: } 11,
{ 17: } 11,
{ 18: } 11,
{ 19: } 11,
{ 20: } 12,
{ 21: } 12,
{ 22: } 12,
{ 23: } 12,
{ 24: } 12,
{ 25: } 17,
{ 26: } 21,
{ 27: } 21,
{ 28: } 26,
{ 29: } 27,
{ 30: } 27,
{ 31: } 27,
{ 32: } 27,
{ 33: } 27,
{ 34: } 27,
{ 35: } 27,
{ 36: } 29,
{ 37: } 35,
{ 38: } 35,
{ 39: } 35,
{ 40: } 35,
{ 41: } 35,
{ 42: } 37,
{ 43: } 40,
{ 44: } 40,
{ 45: } 40,
{ 46: } 40,
{ 47: } 40,
{ 48: } 40,
{ 49: } 40,
{ 50: } 40,
{ 51: } 40,
{ 52: } 40,
{ 53: } 40,
{ 54: } 44,
{ 55: } 44,
{ 56: } 44,
{ 57: } 50,
{ 58: } 50,
{ 59: } 50,
{ 60: } 51,
{ 61: } 55,
{ 62: } 55,
{ 63: } 55,
{ 64: } 55,
{ 65: } 55,
{ 66: } 55,
{ 67: } 56,
{ 68: } 56,
{ 69: } 62,
{ 70: } 62,
{ 71: } 62,
{ 72: } 66,
{ 73: } 66,
{ 74: } 69,
{ 75: } 69,
{ 76: } 73,
{ 77: } 73,
{ 78: } 73,
{ 79: } 73,
{ 80: } 76,
{ 81: } 76,
{ 82: } 76,
{ 83: } 79,
{ 84: } 79,
{ 85: } 79,
{ 86: } 79
);

yyr : array [1..yynrules] of YYRRec = (
{ 1: } ( len: 1; sym: -2; name: 'parse_goal'; body: 'object_decl' ),
{ 2: } ( len: 4; sym: -3; name: 'object_decl'; body: 'object_kind identifier prop_decl tkEnd' ),
{ 3: } ( len: 3; sym: -3; name: 'object_decl'; body: 'object_kind identifier tkEnd' ),
{ 4: } ( len: 6; sym: -3; name: 'object_decl'; body: 'object_kind identifier tkColon identifier prop_decl tkEnd' ),
{ 5: } ( len: 9; sym: -3; name: 'object_decl'; body: 'object_kind identifier tkColon identifier tkSquareOpen tkInteger tkSquareClose prop_decl tkEnd' ),
{ 6: } ( len: 5; sym: -3; name: 'object_decl'; body: 'object_kind identifier tkColon identifier tkEnd' ),
{ 7: } ( len: 1; sym: -4; name: 'object_kind'; body: 'tkObject' ),
{ 8: } ( len: 1; sym: -4; name: 'object_kind'; body: 'tkInline' ),
{ 9: } ( len: 1; sym: -4; name: 'object_kind'; body: 'tkInherited' ),
{ 10: } ( len: 1; sym: -6; name: 'prop_decl'; body: 'object_decl' ),
{ 11: } ( len: 3; sym: -6; name: 'prop_decl'; body: 'identifier tkEqual prop_value' ),
{ 12: } ( len: 4; sym: -6; name: 'prop_decl'; body: 'prop_decl identifier tkEqual prop_value' ),
{ 13: } ( len: 2; sym: -6; name: 'prop_decl'; body: 'prop_decl object_decl' ),
{ 14: } ( len: 1; sym: -7; name: 'prop_value'; body: 'primitive_value' ),
{ 15: } ( len: 3; sym: -7; name: 'prop_value'; body: 'tkLower item_decl tkGreater' ),
{ 16: } ( len: 2; sym: -7; name: 'prop_value'; body: 'tkLower tkGreater' ),
{ 17: } ( len: 3; sym: -7; name: 'prop_value'; body: 'tkSquareOpen set_elements tkSquareClose' ),
{ 18: } ( len: 3; sym: -7; name: 'prop_value'; body: 'tkRoundOpen prop_value_list tkRoundClose' ),
{ 19: } ( len: 1; sym: -11; name: 'prop_value_list'; body: 'primitive_list' ),
{ 20: } ( len: 3; sym: -11; name: 'prop_value_list'; body: 'tkRoundOpen prop_value_list tkRoundClose' ),
{ 21: } ( len: 4; sym: -11; name: 'prop_value_list'; body: 'prop_value_list tkRoundOpen prop_value_list tkRoundClose' ),
{ 22: } ( len: 3; sym: -9; name: 'item_decl'; body: 'identifier prop_decl tkEnd' ),
{ 23: } ( len: 2; sym: -9; name: 'item_decl'; body: 'identifier tkEnd' ),
{ 24: } ( len: 4; sym: -9; name: 'item_decl'; body: 'item_decl identifier prop_decl tkEnd' ),
{ 25: } ( len: 3; sym: -9; name: 'item_decl'; body: 'item_decl identifier tkEnd' ),
{ 26: } ( len: 0; sym: -10; name: 'set_elements'; body: '' ),
{ 27: } ( len: 1; sym: -10; name: 'set_elements'; body: 'identifier' ),
{ 28: } ( len: 3; sym: -10; name: 'set_elements'; body: 'set_elements tkComma identifier' ),
{ 29: } ( len: 1; sym: -12; name: 'primitive_list'; body: 'primitive_value' ),
{ 30: } ( len: 2; sym: -12; name: 'primitive_list'; body: 'primitive_list primitive_value' ),
{ 31: } ( len: 1; sym: -8; name: 'primitive_value'; body: 'tkBinary' ),
{ 32: } ( len: 1; sym: -8; name: 'primitive_value'; body: 'tkInteger' ),
{ 33: } ( len: 2; sym: -8; name: 'primitive_value'; body: 'tkMinus tkInteger' ),
{ 34: } ( len: 2; sym: -8; name: 'primitive_value'; body: 'tkPlus tkInteger' ),
{ 35: } ( len: 1; sym: -8; name: 'primitive_value'; body: 'tkFloat' ),
{ 36: } ( len: 2; sym: -8; name: 'primitive_value'; body: 'tkMinus tkFloat' ),
{ 37: } ( len: 2; sym: -8; name: 'primitive_value'; body: 'tkPlus tkFloat' ),
{ 38: } ( len: 1; sym: -8; name: 'primitive_value'; body: 'identifier' ),
{ 39: } ( len: 1; sym: -8; name: 'primitive_value'; body: 'string_literal' ),
{ 40: } ( len: 1; sym: -14; name: 'string_literal'; body: 'tkStringLiteral' ),
{ 41: } ( len: 1; sym: -14; name: 'string_literal'; body: 'tkAsciiChar' ),
{ 42: } ( len: 3; sym: -14; name: 'string_literal'; body: 'string_literal tkPlus tkStringLiteral' ),
{ 43: } ( len: 2; sym: -14; name: 'string_literal'; body: 'string_literal tkAsciiChar' ),
{ 44: } ( len: 2; sym: -14; name: 'string_literal'; body: 'string_literal tkStringLiteral' ),
{ 45: } ( len: 1; sym: -5; name: 'identifier'; body: 'tkIdentifier' ),
{ 46: } ( len: 1; sym: -5; name: 'identifier'; body: 'tkObject' ),
{ 47: } ( len: 1; sym: -5; name: 'identifier'; body: 'tkInherited' ),
{ 48: } ( len: 1; sym: -5; name: 'identifier'; body: 'tkInline' ),
{ 49: } ( len: 1; sym: -5; name: 'identifier'; body: 'tkEnd' ),
{ 50: } ( len: 3; sym: -5; name: 'identifier'; body: 'identifier tkPoint tkIdentifier' )
);

type                                        
  TYYToken = record                         
    Id : Integer;                           
    Name : String;                          
    Body : String;                          
  end;                                      
const                                       
  tkn_lst_sz = 26;
  tkn_lst : array [1..26] of TYYToken = (
    ( Id : 257; Name : 'tkObject'; Body : ''),
    ( Id : 258; Name : 'tkIdentifier'; Body : ''),
    ( Id : 259; Name : 'tkInherited'; Body : ''),
    ( Id : 260; Name : 'tkInline'; Body : ''),
    ( Id : 261; Name : 'tkEnd'; Body : ''),
    ( Id : 262; Name : 'tkStringLiteral'; Body : ''),
    ( Id : 263; Name : 'tkAsciiChar'; Body : ''),
    ( Id : 264; Name : 'tkSquareOpen'; Body : ''),
    ( Id : 265; Name : 'tkSquareClose'; Body : ''),
    ( Id : 266; Name : 'tkRoundOpen'; Body : ''),
    ( Id : 267; Name : 'tkRoundClose'; Body : ''),
    ( Id : 268; Name : 'tkBinary'; Body : ''),
    ( Id : 269; Name : 'tkInteger'; Body : ''),
    ( Id : 270; Name : 'tkFloat'; Body : ''),
    ( Id : 271; Name : 'tkColon'; Body : ''),
    ( Id : 272; Name : 'tkSemiColon'; Body : ''),
    ( Id : 273; Name : 'tkEqual'; Body : ''),
    ( Id : 274; Name : 'tkMinus'; Body : ''),
    ( Id : 275; Name : 'tkGreater'; Body : ''),
    ( Id : 276; Name : 'tkLower'; Body : ''),
    ( Id : 277; Name : 'tkPoint'; Body : ''),
    ( Id : 278; Name : 'tkComma'; Body : ''),
    ( Id : 279; Name : 'tkCRLF'; Body : ''),
    ( Id : 280; Name : 'tkSpace'; Body : ''),
    ( Id : 281; Name : 'tkJunk'; Body : ''),
    ( Id : 282; Name : 'tkUnknown'; Body : '')
  );

class function TTemplatedParser.yyruleCount : Word;
begin
  Result := yynrules;
end;

class function TTemplatedParser.yyruleId(Index : Word) : Integer;
begin
  Result := Index;
end;

class function TTemplatedParser.yyruleName(Index : Word) : String;
begin
  Result := yyr[Index].name;
end;

class function TTemplatedParser.yyruleBody(Index : Word) : String;
begin
  Result := yyr[Index].body;
end;

class function TTemplatedParser.yyruleLen(Index : Word) : Integer;
begin
  Result := yyr[Index].len;
end;

class function TTemplatedParser.yytokenCount : Word;
begin
  Result := tkn_lst_sz;
end;

class function TTemplatedParser.yytokenId(Index : Word) : Integer;
begin
  Result := tkn_lst[Index].Id;
end;

class function TTemplatedParser.yytokenName(Index : Word) : String;
begin
  Result := tkn_lst[Index].Name;
end;

class function TTemplatedParser.yytokenBody(Index : Word) : String;
begin
  Result := tkn_lst[Index].Body;
end;


const _error = 256; (* error token *)

function TTemplatedParser.yyparse : Boolean;

  (* search action table *)
  function yyact(state, sym : Integer; var act : Integer) : Boolean;
  var k : Integer;
  begin
    k := yyal[state];
    while (k<=yyah[state]) and (yya[k].sym<>sym) do inc(k);
    if k>yyah[state] then
      yyact := false
    else
      begin
        act := yya[k].act;
        yyact := true;
      end;
  end(*yyact*);

  (* search goto table *)
  function yygoto(state, sym : Integer; var nstate : Integer) : Boolean;
  var k : Integer;
  begin
    k := yygl[state];
    while (k<=yygh[state]) and (yyg[k].sym<>sym) do inc(k);
    if k>yygh[state] then
      yygoto := false
    else
      begin
        nstate := yyg[k].act;
        yygoto := true;
      end;
  end(*yygoto*);

label parse, next, error, errlab, shift, reduce, accept, abort;

var
  token : TOYParserToken;
  steps : Integer;

begin(*parse*)

  (* initialize: *)
  steps := 0; yystate := 0; yychar := -1; yynerrs := 0; yyerrflag := 0; yysp := 0;

{$ifdef yydebug}
  yydebug := true;
{$else}
  yydebug := false;
{$endif}

parse:

  (* push state and value: *)
  inc(yysp);
  if yysp>yymaxdepth then
    begin
      raise Exception.Create('Parse stack overflow.');
    end;
  yys[yysp] := yystate;              
  yyv[yysp] := yyval;

next:

  (* check if we can keep going with the evaluation *)
  if ((steps mod 100) = 0) and (not yycancontinue) then begin
    raise Exception.Create('Processing aborted.');
  end;
  Inc(steps);

  if (yyd[yystate]=0) and (yychar=-1) then
    (* get next symbol *)
    begin
      yylval := yylex;
      if yylval.Lexer <> nil then begin
        yychar := yylval.frame.Id;
      end else begin
        yychar := 0;
      end;
      if yychar<0 then yychar := 0;
    end;

  if yydebug then yyhint('State ' + IntToStr(yystate) + ', Char ' + IntToStr(yychar)+ '.');

  (* determine parse action: *)
  yyn := yyd[yystate];
  if yyn<>0 then goto reduce; (* simple state *)

  (* no default action; search parse table *)
  if not yyact(yystate, yychar, yyn) then goto error
  else if yyn>0 then                      goto shift
  else if yyn<0 then                      goto reduce
  else                                    goto accept;

error:

  (* error; start error recovery: *)
  if yyerrflag=0 then begin
    // yywarning('Syntax error.');
  end;

errlab:

  if yyerrflag=0 then inc(yynerrs);     (* new error *)

  if yyerrflag<=2 then                  (* incomplete recovery; try again *)
    begin
      yyerrflag := 3;
      (* uncover a state with shift action on error token *)
      while (yysp>0) and not ( yyact(yys[yysp], _error, yyn) and
                               (yyn>0) ) do
        begin
          if yydebug then
            if yysp>1 then
              yyhint('Error recovery pops state ' + IntToStr(yys[yysp]) + ', uncovers ' + IntToStr(yys[yysp-1]) + '.')
            else
              yyhint('Error recovery fails ... abort.');
          dec(yysp);
        end;
      if yysp=0 then goto abort; (* parser has fallen from stack; abort *)
      yystate := yyn;            (* simulate shift on error *)
      goto parse;
    end
  else                                  (* no shift yet; discard symbol *)
    begin
      if yydebug then yyhint('Error recovery discards char ' + IntToStr(yychar) + '.');
      if yychar=0 then goto abort; (* end of input; abort *)
      yychar := -1; goto next;     (* clear lookahead char and try again *)
    end;

shift:

  (* go to new state, clear lookahead character: *)
  yystate := yyn; yychar := -1; yyval := yylval;
  if yyerrflag>0 then dec(yyerrflag);

  goto parse;

reduce:

  (* execute action, pop rule from stack, and go to next state: *)
  if yydebug then yyhint('Recognized rule (' + yyruleName(-yyn) + ').');

  yyflag := yyfnone;

  (* store current yyval *)
  token := yyval;
  yyaction(-yyn);
  yyframe(yyval, token, -yyn);
  dec(yysp, yyr[-yyn].len);
  if yygoto(yys[yysp], yyr[-yyn].sym, yyn) then yystate := yyn;

  (* handle action calls to accept, abort and error: *)
  case yyflag of
    yyfaccept : goto accept;
    yyfabort  : goto abort;
    yyferror  : goto errlab;
  end;

  goto parse;

accept:

  Result := True; exit;

abort:

  Result := False; exit;

end(*parse*);

