/*
{
	Code Linguine Source Code Parsing/Query Library
	Copyright (C) 2000-2005 Pavel Simakov
	http://www.softwaresecretweapons.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
}

{     DO NOT EDIT BY HAND! THIS FILE IS AUTO GENERATED!       }
*/


%start parse_goal

%token
  tkObject
  tkIdentifier
  tkInherited
  tkInline
  tkEnd

  tkStringLiteral
  tkAsciiChar

  tkSquareOpen
  tkSquareClose
  tkRoundOpen
  tkRoundClose

  tkBinary
  tkInteger
  tkFloat

  tkColon
  tkSemiColon
  tkEqual
  tkMinus
  tkGreater
  tkLower                          
  tkPoint
  tkComma
  
  tkCRLF
  tkSpace
  tkJunk  
  tkUnknown

%%

parse_goal
  : object_decl
  ;

object_decl
  : object_kind identifier prop_decl tkEnd
  | object_kind identifier tkEnd
  | object_kind identifier tkColon identifier prop_decl tkEnd
  | object_kind identifier tkColon identifier tkSquareOpen tkInteger tkSquareClose prop_decl tkEnd  
  | object_kind identifier tkColon identifier tkEnd                   
  ;

object_kind
  : tkObject
  | tkInline                                           
  | tkInherited
  ;

prop_decl                                
  : object_decl
  | identifier tkEqual prop_value
  | prop_decl identifier tkEqual prop_value
  | prop_decl object_decl
  ;

prop_value
  : primitive_value
  | tkLower item_decl tkGreater
  | tkLower tkGreater
  | tkSquareOpen set_elements tkSquareClose
  | tkRoundOpen prop_value_list tkRoundClose
  ;

prop_value_list
  : primitive_list
  | tkRoundOpen prop_value_list tkRoundClose
  | prop_value_list tkRoundOpen prop_value_list tkRoundClose
  ;

item_decl
  : identifier prop_decl tkEnd
  | identifier tkEnd                                           
  | item_decl identifier prop_decl tkEnd
  | item_decl identifier tkEnd
  ;                        

set_elements
  : /* empty */ {}
  | identifier
  | set_elements tkComma identifier
  ;

primitive_list
  : primitive_value
  | primitive_list primitive_value
  ;

primitive_value
  : tkBinary
  | tkInteger
  | tkMinus tkInteger
  | tkPlus tkInteger
  | tkFloat
  | tkMinus tkFloat
  | tkPlus tkFloat
  | identifier
  | string_literal
  ;

string_literal
  : tkStringLiteral
  | tkAsciiChar
  | string_literal tkPlus tkStringLiteral
  | string_literal tkAsciiChar
  | string_literal tkStringLiteral
  ;                                 

identifier
  : tkIdentifier
  | tkObject
  | tkInherited
  | tkInline
  | tkEnd
  | identifier tkPoint tkIdentifier
  ;              
  
%%

