{
	Code Linguine Source Code Parsing/Query Library
	Copyright (C) 2000-2005 Pavel Simakov
	http://www.softwaresecretweapons.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
}

{$I oycl.inc}

unit OYVerInfo;

interface

const
  cOptionsFile = 'linguine.bin';
  cAboutFile = 'about.rtf';
  cCopyRight = 'Copyright  2000, 2001 Outplay Inc.';

  { this functions provide general purpose veriosn information }
  function OYExeNameNoExtention : WideString;
  function OYExeNameWithExtention : WideString;
  function OYMajorVersion : WideString;
  function OYMinorVersion : WideString;
  function OYRelease : WideString;
  function OYBuild : WideString;
  function OYCompanyName : WideString;
  function OYProductName : WideString;
  function OYProductNameNoVersion : WideString;
  function OYProductGuid : WideString;
  function OYProductUrl : WideString;
  function OYProductVersionInfo : WideString;
  function OYProductEdition : WideString;

implementation

uses { vlc } Forms, SysUtils,
     { oy } OYUtility;

const
  cVerMajor = '1';
  cVerMinor = '1';
  cVerRelease = '0';
  cVerBuild = '44';
  cProductName = 'codeLinguine';
  cRegistryRoot = 'Software\Outplay\' + cProductName + '\' + cVerMajor + '.' + cVerMinor + '\';
  cEdition = 'Global Edition';
  cProductUrl = 'http://www.codeLinguine.com';
  cPackages = 'Packages';

function OYExeNameNoExtention : WideString;
begin
  Result := ChangeFileExt(ExtractFileName(Application.ExeName), '');
end;

function OYExeNameWithExtention : WideString;
begin
  Result := ExtractFileName(Application.ExeName);
end;

function OYMajorVersion : WideString;
begin
  Result := cVerMajor;
end;

function OYMinorVersion : WideString;
begin
  Result := cVerMinor;
end;

function OYRelease : WideString;
begin
  Result := cVerRelease;
end;

function OYBuild : WideString;
begin
  Result := cVerBuild;
end;

function OYCompanyName : WideString;
begin
  Result := 'Outplay Inc.';
end;

function OYProductName : WideString;
begin
  Result := OYProductNameNoVersion + ' ' + cVerMajor + '.' + cVerMinor;
end;

function OYProductNameNoVersion : WideString;
begin
  Result := cProductName;
end;

function OYProductGuid : WideString;
begin
  Result := '{032DE83F-D365-493B-89E6-CD0CB6C22111}';
end;

function OYProductUrl : WideString;
begin
  Result := cProductUrl;
end;

function OYProductVersionInfo : WideString;
begin
  Result := cVerMajor + '.' + cVerMinor + '.' + cVerRelease + '.' + cVerBuild;
end;

function OYProductEdition : WideString;
begin
  Result := cEdition;
end;


end.
