{
	Code Linguine Source Code Parsing/Query Library
	Copyright (C) 2000-2005 Pavel Simakov
	http://www.softwaresecretweapons.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
}

{$I oycl.inc}  

unit OYLexLib;

interface

uses { ly } LexLib; 

type
  TOYLexer = class(TLexer)
  end;

  TOYLexerClass = class of TOYLexer;

  { function to compute text hash; use this function to
  compute hash values of new strings to be added }
  function OYGetTokenHash(Token : String) : Integer;
  procedure OYLexerCodeGenerate(FileName : String);

implementation

uses { vcl } SysUtils, Classes;

function OYGetTokenHash(Token : String) : Integer;
var
  I: Integer;
begin
  Result := 0;
  for i := 1 to Length(Token) do begin
    Result := Result + Ord(Token[i]);
  end;
end;

procedure OYLexerCodeGenerate(FileName : String);
var
  aL : TStrings;
  i, j : Integer;
  aO : String;
begin
  aL := TStringList.Create;
  try
    aL.LoadFromFile(FileName);
    for i := 0 to aL.Count - 1 do begin
      aL.Objects[i] := Pointer(OYGetTokenHash(aL[i]));
    end;
    for i := 0 to aL.Count - 1 do begin
      for j := 0 to aL.Count - 1 do begin
        if Integer(aL.Objects[i]) < Integer(aL.Objects[j]) then begin
          aL.Exchange(i, j);
        end;
      end;
    end;
    for i := 0 to aL.Count - 1 do begin
      if i = 0 then begin
        aO := aO +
          IntToStr(Integer(aL.Objects[i])) + ' : begin'#$D#$A;
      end;

      if (i > 0) and ((Integer(aL.Objects[i])) <> Integer(aL.Objects[i - 1])) then begin
        aO := aO +
          'end;'#$D#$A +
          IntToStr(Integer(aL.Objects[i])) + ' : begin'#$D#$A;
      end;
      aO := aO + '  if aToken = ''' + aL[i] + ''' then Result := tk' + aL[i][1] + LowerCase(Copy(aL[i], 2, Length(aL[i]))) + ';'#$D#$A;

      if i = aL.Count - 1 then begin
        aO := aO + 'end;'#$D#$A;
      end;
    end;
    aL.Text := aO;
    aL.SaveToFile(FileName + '.pas');
  finally
    aL.Free;
  end;
end;

end.
