{
	Code Linguine Source Code Parsing/Query Library
	Copyright (C) 2000-2005 Pavel Simakov
	http://www.softwaresecretweapons.com

	This library is free software; you can redistribute it and/or
	modify it under the terms of the GNU Lesser General Public
	License as published by the Free Software Foundation; either
	version 2.1 of the License, or (at your option) any later version.

	This library is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public
	License along with this library; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
}

{$I oycl.inc}  

unit OYParserToken;

interface

type
  { parser can have errors, warnings, or hints }
  TOYParseEvent = procedure (Url,Reason, Line, Token : WideString; lineno, colno : Integer) of object;
  TOYParserCanContinue = function : Boolean of Object;

type
  { general puspose lexer frame; each token recognized by
  lexer is this frame }
  TOYLexerFrame = packed record
    id : Word;
    leftLineIndex : Integer;
    leftColIndex : SmallInt;
    rightLineIndex : Integer;
    rightColIndex : SmallInt;
  end;
  POYLexerFrame = ^TOYLexerFrame;

  { general purpose parse map frame; each rule that is closed by
  parser has this frame }
  TOYParserFrame = packed record
    Left : Integer;
    Right : Integer;
    Rule : Word;
    Index : Integer;
  end;
  POYParserFrame = ^TOYParserFrame;

  { general purpose token; token does not contain text in it,
    but it can hold pointer to parent parser object to retrieve
    the text}
  TOYParserToken = packed record
    Index : Integer;
    Frame : TOYLexerFrame;
    Lexer : TObject;
  end;
  POYParserToken = ^TOYParserToken;

implementation

end.
